function [downstream_profits upstream_profits prices market_share_big_market market_share_small_market consumer_buys_big_market consumer_buys_small_market time_watched]=bargaining_downstream_equilibrium(last_prices,bundles,input_cost,regulation_option,preferences,channel)


% tic

beta_i_big_market=preferences{1};
channels_utility_big_market=preferences{2};
pre_gamma_big_market=preferences{3};
beta_i_small_market=preferences{4};
channels_utility_small_market=preferences{5};
pre_gamma_small_market=preferences{6};
logit_var=preferences{7};
market_size=preferences{8};
utility_constants=preferences{9};
outside_good_utility=preferences{11};

p1=last_prices{1};
p2=last_prices{2};
p3=last_prices{3};
p4=last_prices{4};
prices=[p1 p2 p3 p4];
track_prices_1=p1;
track_prices_2=p2;
track_prices_3=p3;
track_prices_4=p4;

downstream_equilibrium_tolerance=1;
if (regulation_option==1)
desired_tolerance=1e-6;
optimization_options=optimset('MaxFunEvals',500000,'MaxIter',500000,'TolX',1e-7,'TolFun',100);
elseif (regulation_option==2)
desired_tolerance=1e-4;
optimization_options=optimset('MaxFunEvals',50000,'MaxIter',50000,'TolX',1e-5,'TolFun',100);
elseif (regulation_option==3)
load tt_parameters
desired_tolerance=1e-3;
optimization_options=optimset('MaxFunEvals',50000,'MaxIter',50000,'TolX',1e-5,'TolFun',100); 


pre_price=bundles.*input_cost;
for k=1:5
    p1(k)=sum(pre_price(package_channels{k},1));
    p2(k)=sum(pre_price(package_channels{k},2));
    p3(k)=sum(pre_price(package_channels{k},3));
    p4(k)=sum(pre_price(package_channels{k},4));
end

run bargaining_tt_downstream_equilibrium_preliminary


elseif (regulation_option==4)
desired_tolerance=1e-4;
optimization_options=optimset('MaxFunEvals',50000,'MaxIter',50000,'TolX',1e-5,'TolFun',100);
end
while (downstream_equilibrium_tolerance>desired_tolerance)
    
    
    if (regulation_option==1)
    [p1 fval1]=fminsearch(@(z1) bargaining_downstream_firm_profits_mex(1,z1,p2,p3,p4,bundles,beta_i_big_market,channels_utility_big_market,beta_i_small_market,channels_utility_small_market,input_cost,logit_var,regulation_option,market_size,0,utility_constants,outside_good_utility),p1,optimization_options);
%     disp('Big cable prices set')
    
    [p2 fval2]=fminsearch(@(z2) bargaining_downstream_firm_profits_mex(2,p1,z2,p3,p4,bundles,beta_i_big_market,channels_utility_big_market,beta_i_small_market,channels_utility_small_market,input_cost,logit_var,regulation_option,market_size,0,utility_constants,outside_good_utility),p2,optimization_options);
%     disp('Small cable prices set')
    
    [p3 fval3]=fminsearch(@(z3) bargaining_downstream_firm_profits_mex(3,p1,p2,z3,p4,bundles,beta_i_big_market,channels_utility_big_market,beta_i_small_market,channels_utility_small_market,input_cost,logit_var,regulation_option,market_size,0,utility_constants,outside_good_utility),p3,optimization_options);
%     disp('DirecTV prices set')
    
    [p4 fval4]=fminsearch(@(z4) bargaining_downstream_firm_profits_mex(4,p1,p2,p3,z4,bundles,beta_i_big_market,channels_utility_big_market,beta_i_small_market,channels_utility_small_market,input_cost,logit_var,regulation_option,market_size,0,utility_constants,outside_good_utility),p4,optimization_options);
%     disp('Dish prices set') 

    elseif (regulation_option==2)
        % BSP
        
        [consumer_top_ten channel_is_top_ten]=bargaining_bsp_preliminaries(bundles,channels_utility_big_market,channels_utility_small_market);
        
        [p1 fval1]=fminsearch(@(z1) bargaining_bsp_downstream_firm_profits_mex(1,z1,p2,p3,p4,bundles,beta_i_big_market,channels_utility_big_market,beta_i_small_market,channels_utility_small_market,input_cost,logit_var,utility_constants,market_size,0,consumer_top_ten,channel_is_top_ten),p1,optimization_options);
        
        [p2 fval2]=fminsearch(@(z2) bargaining_bsp_downstream_firm_profits_mex(2,p1,z2,p3,p4,bundles,beta_i_big_market,channels_utility_big_market,beta_i_small_market,channels_utility_small_market,input_cost,logit_var,utility_constants,market_size,0,consumer_top_ten,channel_is_top_ten),p2,optimization_options);

        [p3 fval3]=fminsearch(@(z3) bargaining_bsp_downstream_firm_profits_mex(3,p1,p2,z3,p4,bundles,beta_i_big_market,channels_utility_big_market,beta_i_small_market,channels_utility_small_market,input_cost,logit_var,utility_constants,market_size,0,consumer_top_ten,channel_is_top_ten),p3,optimization_options);
        
        [p4 fval4]=fminsearch(@(z4) bargaining_bsp_downstream_firm_profits_mex(4,p1,p2,p3,z4,bundles,beta_i_big_market,channels_utility_big_market,beta_i_small_market,channels_utility_small_market,input_cost,logit_var,utility_constants,market_size,0,consumer_top_ten,channel_is_top_ten),p4,optimization_options);    
        
    elseif (regulation_option==3)
        

         p1(6)=fminsearch(@(z) uni_bargaining_tt_downstream_firm_profits_fast(1,6,z,p1,p2,p3,p4,bundles,beta_i_big_market,channels_utility_big_market,beta_i_small_market,channels_utility_small_market,input_cost,logit_var,regulation_option,market_size,0,utility_constants,outside_good_utility,in_package,new_packages,package_utility_big_market,within_cable_denominator_big_market,within_directv_denominator_big_market,within_dish_denominator_big_market,within_cable_share_big_market,within_directv_share_big_market,within_dish_share_big_market,package_utility_small_market,within_cable_denominator_small_market,within_directv_denominator_small_market,within_dish_denominator_small_market,within_cable_share_small_market,within_directv_share_small_market,within_dish_share_small_market),p1(6),optimization_options);
         p2(6)=fminsearch(@(z) uni_bargaining_tt_downstream_firm_profits_fast(2,6,z,p1,p2,p3,p4,bundles,beta_i_big_market,channels_utility_big_market,beta_i_small_market,channels_utility_small_market,input_cost,logit_var,regulation_option,market_size,0,utility_constants,outside_good_utility,in_package,new_packages,package_utility_big_market,within_cable_denominator_big_market,within_directv_denominator_big_market,within_dish_denominator_big_market,within_cable_share_big_market,within_directv_share_big_market,within_dish_share_big_market,package_utility_small_market,within_cable_denominator_small_market,within_directv_denominator_small_market,within_dish_denominator_small_market,within_cable_share_small_market,within_directv_share_small_market,within_dish_share_small_market),p2(6),optimization_options);
         p3(6)=fminsearch(@(z) uni_bargaining_tt_downstream_firm_profits_fast(3,6,z,p1,p2,p3,p4,bundles,beta_i_big_market,channels_utility_big_market,beta_i_small_market,channels_utility_small_market,input_cost,logit_var,regulation_option,market_size,0,utility_constants,outside_good_utility,in_package,new_packages,package_utility_big_market,within_cable_denominator_big_market,within_directv_denominator_big_market,within_dish_denominator_big_market,within_cable_share_big_market,within_directv_share_big_market,within_dish_share_big_market,package_utility_small_market,within_cable_denominator_small_market,within_directv_denominator_small_market,within_dish_denominator_small_market,within_cable_share_small_market,within_directv_share_small_market,within_dish_share_small_market),p3(6),optimization_options);
         p4(6)=fminsearch(@(z) uni_bargaining_tt_downstream_firm_profits_fast(4,6,z,p1,p2,p3,p4,bundles,beta_i_big_market,channels_utility_big_market,beta_i_small_market,channels_utility_small_market,input_cost,logit_var,regulation_option,market_size,0,utility_constants,outside_good_utility,in_package,new_packages,package_utility_big_market,within_cable_denominator_big_market,within_directv_denominator_big_market,within_dish_denominator_big_market,within_cable_share_big_market,within_directv_share_big_market,within_dish_share_big_market,package_utility_small_market,within_cable_denominator_small_market,within_directv_denominator_small_market,within_dish_denominator_small_market,within_cable_share_small_market,within_directv_share_small_market,within_dish_share_small_market),p4(6),optimization_options);
        
%    
%    
%     p_tol=1;
%     while (p_tol>1e-4)
%     p1_old=p1;
%     for yyy=1:5
%        p1([yyy 6])=fminsearch(@(z) uni_bargaining_tt_downstream_firm_profits(1,[yyy 6],z,p1,p2,p3,p4,bundles,beta_i_big_market,channels_utility_big_market,beta_i_small_market,channels_utility_small_market,input_cost,logit_var,regulation_option,market_size,0,utility_constants,outside_good_utility,in_package,new_packages),p1([yyy 6]),optimization_options);
%     end    
%     p_tol = max(abs(p1-p1_old));
%     disp(p_tol)
%     end
%     
%     p_tol=1;
%     while (p_tol>1e-4)
%     p2_old=p2;
%     for yyy=1:5
%        p2([yyy 6])=fminsearch(@(z) uni_bargaining_tt_downstream_firm_profits(2,[yyy 6],z,p1,p2,p3,p4,bundles,beta_i_big_market,channels_utility_big_market,beta_i_small_market,channels_utility_small_market,input_cost,logit_var,regulation_option,market_size,0,utility_constants,outside_good_utility,in_package,new_packages),p2([yyy 6]),optimization_options);
%     end    
%     p_tol = max(abs(p2-p2_old));
%     end
%     
%     p_tol=1;
%     while (p_tol>1e-4)
%     p3_old=p3;
%     for yyy=1:5
%        p3([yyy 6])=fminsearch(@(z) uni_bargaining_tt_downstream_firm_profits(3,[yyy 6],z,p1,p2,p3,p4,bundles,beta_i_big_market,channels_utility_big_market,beta_i_small_market,channels_utility_small_market,input_cost,logit_var,regulation_option,market_size,0,utility_constants,outside_good_utility,in_package,new_packages),p3([yyy 6]),optimization_options);
%     end    
%     p_tol = max(abs(p3-p3_old));
%     end
%     
%     p_tol=1;
%     while (p_tol>1e-4)
%     p4_old=p4;
%     for yyy=1:5
%        p4([yyy 6])=fminsearch(@(z) uni_bargaining_tt_downstream_firm_profits(4,[yyy 6],z,p1,p2,p3,p4,bundles,beta_i_big_market,channels_utility_big_market,beta_i_small_market,channels_utility_small_market,input_cost,logit_var,regulation_option,market_size,0,utility_constants,outside_good_utility,in_package,new_packages),p4([yyy 6]),optimization_options);
%     end    
%     p_tol = max(abs(p4-p4_old));
%     end
       
        
%           disp([p1 p2 p3 p4])
    elseif (regulation_option==4)
 
    %[p1 fval1]=fminsearch(@(z1) bargaining_alc_downstream_firm_profits_mex(1,z1,p2,p3,p4,bundles,beta_i_big_market,channels_utility_big_market,beta_i_small_market,channels_utility_small_market,input_cost,logit_var,regulation_option,market_size,0,utility_constants,outside_good_utility),p1,optimization_options);
p1(1:49)=input_cost(:,1);
p2(1:49)=input_cost(:,2);
p3(1:49)=input_cost(:,3);
p4(1:49)=input_cost(:,4);

%     p_tol=1;
%     while (p_tol>1e-4)
%     p1_old=p1;
%     for yyy=1:49
%         if (bundles(yyy,1)==1)
%             p1([yyy 50])=fminsearch(@(z) uni_bargaining_alc_downstream_firm_profits(1,[yyy 50],z,p1,p2,p3,p4,bundles,beta_i_big_market,channels_utility_big_market,beta_i_small_market,channels_utility_small_market,input_cost,logit_var,regulation_option,market_size,0,utility_constants,outside_good_utility),p1([yyy 50]),optimization_options);
%         else
%             p1(yyy)=input_cost(yyy,1);
%         end
%     end    
%     p_tol = max(abs(p1-p1_old));
% %     disp(p_tol)
%     end
    p1(50)=fminsearch(@(z) uni_bargaining_alc_downstream_firm_profits(1,channel,z,p1,p2,p3,p4,bundles,beta_i_big_market,channels_utility_big_market,beta_i_small_market,channels_utility_small_market,input_cost,logit_var,regulation_option,market_size,0,utility_constants,outside_good_utility),p1(50),optimization_options);

%     disp('Big cable prices set')
    
%     [p2 fval2]=fminsearch(@(z2) bargaining_alc_downstream_firm_profits_mex(2,p1,z2,p3,p4,bundles,beta_i_big_market,channels_utility_big_market,beta_i_small_market,channels_utility_small_market,input_cost,logit_var,regulation_option,market_size,0,utility_constants,outside_good_utility),p2,optimization_options);
%     p_tol=1;    
%     while (p_tol>1e-4)
%     p2_old=p2;
%     for yyy=1:49
%     if (bundles(yyy,2)==1)
%     p2([yyy 50])=fminsearch(@(z) uni_bargaining_alc_downstream_firm_profits(2,[yyy 50],z,p1,p2,p3,p4,bundles,beta_i_big_market,channels_utility_big_market,beta_i_small_market,channels_utility_small_market,input_cost,logit_var,regulation_option,market_size,0,utility_constants,outside_good_utility),p2([yyy 50]),optimization_options);
%     else
%     p2(yyy)=input_cost(yyy,2);
%     end        
%     end    
%     p_tol = max(abs(p2-p2_old));
% %         disp(p_tol)
%     end
    p2(50)=fminsearch(@(z) uni_bargaining_alc_downstream_firm_profits(2,channel,z,p1,p2,p3,p4,bundles,beta_i_big_market,channels_utility_big_market,beta_i_small_market,channels_utility_small_market,input_cost,logit_var,regulation_option,market_size,0,utility_constants,outside_good_utility),p2(50),optimization_options);
%     disp('Small cable prices set')
    
%     [p3 fval3]=fminsearch(@(z3) bargaining_alc_downstream_firm_profits_mex(3,p1,p2,z3,p4,bundles,beta_i_big_market,channels_utility_big_market,beta_i_small_market,channels_utility_small_market,input_cost,logit_var,regulation_option,market_size,0,utility_constants,outside_good_utility),p3,optimization_options);
%     p_tol=1;    
%     while (p_tol>1e-4)
%     p3_old=p3;
%     for yyy=1:49
%     if (bundles(yyy,3)==1)
%     p3([yyy 50])=fminsearch(@(z) uni_bargaining_alc_downstream_firm_profits(3,[yyy 50],z,p1,p2,p3,p4,bundles,beta_i_big_market,channels_utility_big_market,beta_i_small_market,channels_utility_small_market,input_cost,logit_var,regulation_option,market_size,0,utility_constants,outside_good_utility),p3([yyy 50]),optimization_options);
%     else
%     p3(yyy)=input_cost(yyy,3);
%     end      
%     end    
%     p_tol = max(abs(p3-p3_old));
% %     disp(p_tol)
%     end
    p3(50)=fminsearch(@(z) uni_bargaining_alc_downstream_firm_profits(3,channel,z,p1,p2,p3,p4,bundles,beta_i_big_market,channels_utility_big_market,beta_i_small_market,channels_utility_small_market,input_cost,logit_var,regulation_option,market_size,0,utility_constants,outside_good_utility),p3(50),optimization_options);
% %     disp('DirecTV prices set')
    
%     [p4 fval4]=fminsearch(@(z4) bargaining_alc_downstream_firm_profits_mex(4,p1,p2,p3,z4,bundles,beta_i_big_market,channels_utility_big_market,beta_i_small_market,channels_utility_small_market,input_cost,logit_var,regulation_option,market_size,0,utility_constants,outside_good_utility),p4,optimization_options);
%     p_tol=1;    
%     while (p_tol>1e-4)
%     p4_old=p4;
%     for yyy=1:49
%     if (bundles(yyy,4)==1)
%     p4([yyy 50])=fminsearch(@(z) uni_bargaining_alc_downstream_firm_profits(4,[yyy 50],z,p1,p2,p3,p4,bundles,beta_i_big_market,channels_utility_big_market,beta_i_small_market,channels_utility_small_market,input_cost,logit_var,regulation_option,market_size,0,utility_constants,outside_good_utility),p4([yyy 50]),optimization_options);
%     else
%     p4(yyy)=input_cost(yyy,4);
%     end   
%     end    
%     p_tol = max(abs(p4-p4_old));
% %         disp(p_tol)
%     end
    p4(50)=fminsearch(@(z) uni_bargaining_alc_downstream_firm_profits(4,channel,z,p1,p2,p3,p4,bundles,beta_i_big_market,channels_utility_big_market,beta_i_small_market,channels_utility_small_market,input_cost,logit_var,regulation_option,market_size,0,utility_constants,outside_good_utility),p4(50),optimization_options);
%      disp('Dish prices set')         
        
    end
    
       new_prices=[p1 p2 p3 p4];
       downstream_equilibrium_tolerance=max(max(abs(new_prices-prices)));
       prices=new_prices;
       track_prices_1=[track_prices_1 p1];
       track_prices_2=[track_prices_2 p2];
       track_prices_3=[track_prices_3 p3];
       track_prices_4=[track_prices_4 p4];       
     
%        if (regulation_option>=2)
%      disp(['Downstream Tolerance: ' num2str(downstream_equilibrium_tolerance)])
%      disp('Prices')
%         disp(new_prices)
%        end
end

% save test_bsp_de

if (regulation_option==1)
    consumer_buys_big_market=ones(length(channels_utility_big_market(:,1)),length(channels_utility_big_market(1,:)),3);
    consumer_buys_small_market = ones(length(channels_utility_small_market(:,1)),length(channels_utility_small_market(1,:)),3);
    for k=1:length(channels_utility_big_market(1,:))
        consumer_buys_big_market(:,k,1)=consumer_buys_big_market(:,k,1)*bundles(k,1);
        consumer_buys_big_market(:,k,2)=consumer_buys_big_market(:,k,1)*bundles(k,3);
        consumer_buys_big_market(:,k,3)=consumer_buys_big_market(:,k,1)*bundles(k,4);
        consumer_buys_small_market(:,k,1)=consumer_buys_small_market(:,k,1)*bundles(k,2);
        consumer_buys_small_market(:,k,2)=consumer_buys_small_market(:,k,1)*bundles(k,3);
        consumer_buys_small_market(:,k,3)=consumer_buys_small_market(:,k,1)*bundles(k,4);  
    end
    [player_profits downstream_profits market_share_big_market market_share_small_market upstream_fee_revenue]=bargaining_downstream_firm_profits_mex(1,p1,p2,p3,p4,bundles,beta_i_big_market,channels_utility_big_market,beta_i_small_market,channels_utility_small_market,input_cost,logit_var,regulation_option,market_size,1,utility_constants,outside_good_utility);
    time_watched = bargaining_alc_time_watched_mex(pre_gamma_small_market,pre_gamma_big_market,consumer_buys_small_market,consumer_buys_big_market,market_share_small_market,market_share_big_market,regulation_option,market_size,16);
%     save welfare_measures time_watched market_share_big_market market_share_small_market upstream_fee_revenue
elseif (regulation_option==2)
    [player_profits downstream_profits market_share_big_market market_share_small_market upstream_fee_revenue]=bargaining_bsp_downstream_firm_profits_mex(1,p1,p2,p3,p4,bundles,beta_i_big_market,channels_utility_big_market,beta_i_small_market,channels_utility_small_market,input_cost,logit_var,utility_constants,market_size,1,consumer_top_ten,channel_is_top_ten);
    time_watched=bargaining_bsp_time_watched_mex(pre_gamma_small_market,pre_gamma_big_market,channel_is_top_ten(:,:,[2 3 4]),channel_is_top_ten(:,:,[1 3 4]),market_share_small_market,market_share_big_market,regulation_option,market_size,bundles);
        consumer_buys_big_market=channel_is_top_ten(:,:,[1 3 4]);
    consumer_buys_small_market=channel_is_top_ten(:,:,[2 3 4]);
elseif (regulation_option==3)
    [player_profits downstream_profits market_share_big_market market_share_small_market upstream_fee_revenue]=bargaining_tt_downstream_firm_profits_mex(1,p1,p2,p3,p4,bundles,beta_i_big_market,channels_utility_big_market,beta_i_small_market,channels_utility_small_market,input_cost,logit_var,regulation_option,market_size,1,utility_constants,outside_good_utility,in_package,new_packages);
    [time_watched_big_market time_watched_small_market]=bargaining_tt_time_watched(bundles,market_share_big_market,market_share_small_market,pre_gamma_big_market,pre_gamma_small_market,market_size,in_package,new_packages);
    time_watched=(market_size(1)*mean(time_watched_big_market)' + market_size(2)*mean(time_watched_small_market)')/(sum(market_size));
    consumer_buys_big_market=0;
    consumer_buys_small_market=0;
elseif (regulation_option==4)
    [player_profits downstream_profits market_share_big_market market_share_small_market consumer_buys_big_market consumer_buys_small_market upstream_fee_revenue]=bargaining_alc_downstream_firm_profits_channel_mex(1,p1,p2,p3,p4,bundles,beta_i_big_market,channels_utility_big_market,beta_i_small_market,channels_utility_small_market,input_cost,logit_var,regulation_option,market_size,1,utility_constants,outside_good_utility,channel);
    time_watched=bargaining_alc_time_watched_channel_mex(pre_gamma_small_market,pre_gamma_big_market,consumer_buys_small_market,consumer_buys_big_market,market_share_small_market,market_share_big_market,regulation_option,market_size,bundles,channel);
%         save diagnostics market_share_big_market time_watched consumer_buys_big_market
end

ad_coefficients=preferences{10};
upstream_profits = upstream_fee_revenue + sum(market_size)*length(market_share_big_market(:,1))*ad_coefficients.*(100*time_watched);

last_prices={p1,p2,p3,p4};
if (regulation_option==1)
save last_prices_bundling last_prices
elseif (regulation_option==2)
save last_prices_bsp last_prices
elseif (regulation_option==3)
save last_prices_tt last_prices
elseif (regulation_option==4)
save last_prices_alc last_prices
end

% toc
