function new_input_costs=bargaining_equilibrium(channel,input_cost,bundles,bargaining_parameters,regulation_option,preferences,conglomerate_parameters)

conglomerate=conglomerate_parameters{1};
conglomerate_groups=conglomerate_parameters{2};
channel_to_conglomerate=conglomerate_parameters{3};

current_input_cost=input_cost;
new_input_costs=input_cost;
% track_negotiations=zeros(1,4);
% track_negotiations(1,:)=current_input_cost(channel,:);

bargaining_tolerance=1;
if (regulation_option==1)
desired_tolerance=1e-3;
optimization_options=optimset('MaxFunEvals',50000,'MaxIter',50000,'TolX',1e-6,'TolFun',10);
elseif (regulation_option==2)
desired_tolerance=2e-3;
optimization_options=optimset('MaxFunEvals',50000,'MaxIter',50000,'TolX',1e-4,'TolFun',100);
elseif (regulation_option==3)
desired_tolerance=2e-2;
optimization_options=optimset('MaxFunEvals',50000,'MaxIter',50000,'TolX',1e-3,'TolFun',10);
elseif (regulation_option==4)
desired_tolerance=2e-2;
optimization_options=optimset('MaxFunEvals',50000,'MaxIter',50000,'TolX',1e-3,'TolFun',10);
end

 track_barg_tol=1;
 track_costs=new_input_costs;
 save track_bargaining_equilibrium track_barg_tol track_costs

while bargaining_tolerance>desired_tolerance
    % Compute disagreement payoffs for big cable/channel
    da_bundles=bundles;
    if (conglomerate==0)
    da_bundles(channel,1)=0;
    else
    da_bundles(conglomerate_groups{channel_to_conglomerate(channel)},1)=0;
    end
    da_payoffs=bargaining_disagreement_payoffs(channel,1,da_bundles,new_input_costs,regulation_option,preferences,conglomerate_parameters);


    % Compute Nash bargaining input cost for big cable/channel
    if (conglomerate==0)
    bundles(channel,1)=1;
    else
    bundles(conglomerate_groups{channel_to_conglomerate(channel)},1)=1;
    end    
    if (conglomerate==0)
    new_input_costs(channel,1)=fminsearch(@(z) bargaining_nash_product(z,channel,1,da_payoffs,bundles,bargaining_parameters(channel,1),new_input_costs,regulation_option,preferences,conglomerate_parameters),current_input_cost(channel,1),optimization_options);
    else
     if (regulation_option==1)
     
         
%          new_input_costs(channel,1)=fminsearch(@(z) bargaining_nash_product(z,channel,1,da_payoffs,bundles,bargaining_parameters(channel,1),new_input_costs,regulation_option,preferences,conglomerate_parameters),current_input_cost(channel,1),optimization_options);
    prob = conAssign(@(z) bargaining_nash_product(z,channel,1,da_payoffs,bundles,bargaining_parameters(channel,1),new_input_costs,regulation_option,preferences,conglomerate_parameters), @(z) d_bargaining_nash_product(z,channel,1,da_payoffs,bundles,bargaining_parameters(channel,1),new_input_costs,regulation_option,preferences,conglomerate_parameters),[],[],-Inf,Inf, 'NP', current_input_cost(channel,1));
    prob.KNITRO.options.XTOL=1e-6;
    prob.KNITRO.options.ALG = 3;
    prob.PriLevOpt = 0; % Print one line each iteration
    prob.KNITRO.options.HESSOPT = 3;
    res = tomRun('knitro', prob);
    new_input_costs(channel,1)=res.x_k;
    
     elseif (regulation_option==2 ||  regulation_option==3)
     new_input_costs(conglomerate_groups{channel_to_conglomerate(channel)},1)=fminsearchcon(@(z) bargaining_nash_product(z,conglomerate_groups{channel_to_conglomerate(channel)}(1),1,da_payoffs,bundles,bargaining_parameters(channel,1),new_input_costs,regulation_option,preferences,conglomerate_parameters),new_input_costs(conglomerate_groups{channel_to_conglomerate(channel)},1),zeros(length(conglomerate_groups{channel_to_conglomerate(channel)}),1),[],[],[],[],optimization_options);     
     elseif (regulation_option==4)
         
        %new_input_costs(conglomerate_groups{channel_to_conglomerate(channel)},1)=fminsearch(@(z) bargaining_nash_product(z,conglomerate_groups{channel_to_conglomerate(channel)}(1),1,da_payoffs,bundles,bargaining_parameters(channel,1),new_input_costs,regulation_option,preferences,conglomerate_parameters),new_input_costs(conglomerate_groups{channel_to_conglomerate(channel)},1),optimization_options);     
             
         
     internal_bargaining_tolerance=1;
     while (internal_bargaining_tolerance>1e-2)    
     use_old_costs=new_input_costs(conglomerate_groups{channel_to_conglomerate(channel)},1);
     for i=1:length(conglomerate_groups{channel_to_conglomerate(channel)})
         new_input_costs(conglomerate_groups{channel_to_conglomerate(channel)}(i),1)=fminsearch(@(z) bargaining_nash_product(z,conglomerate_groups{channel_to_conglomerate(channel)}(i),1,da_payoffs,bundles,bargaining_parameters(channel,1),new_input_costs,regulation_option,preferences,conglomerate_parameters),new_input_costs(conglomerate_groups{channel_to_conglomerate(channel)}(i),1),optimization_options);
     end
     internal_bargaining_tolerance=max(abs(new_input_costs(conglomerate_groups{channel_to_conglomerate(channel)},1)-use_old_costs));
     disp([new_input_costs(conglomerate_groups{channel_to_conglomerate(channel)},1) use_old_costs])
     disp(['internal tol big cable:' num2str(internal_bargaining_tolerance)])
     end
     end
    end

disp('Big Cable Negotiations Complete')
    
    
    % Compute disagreement payoffs for small cable/channel
    da_bundles=bundles;
    if (conglomerate==0)
    da_bundles(channel,2)=0;
    else
    da_bundles(conglomerate_groups{channel_to_conglomerate(channel)},2)=0;
    end
    da_payoffs=bargaining_disagreement_payoffs(channel,2,da_bundles,new_input_costs,regulation_option,preferences,conglomerate_parameters);
    % Compute Nash bargaining input cost for small cable/channel 
    if (conglomerate==0)
    bundles(channel,2)=1;
    else
    bundles(conglomerate_groups{channel_to_conglomerate(channel)},2)=1;
    end
    
    if (conglomerate==0)
    new_input_costs(channel,2)=fminsearch(@(z) bargaining_nash_product(z,channel,2,da_payoffs,bundles,bargaining_parameters(channel,2),new_input_costs,regulation_option,preferences,conglomerate_parameters),current_input_cost(channel,2),optimization_options);
    else
     if (regulation_option==1)
     
         
%          new_input_costs(channel,2)=fminsearch(@(z) bargaining_nash_product(z,channel,2,da_payoffs,bundles,bargaining_parameters(channel,2),new_input_costs,regulation_option,preferences,conglomerate_parameters),current_input_cost(channel,2),optimization_options);
    prob = conAssign(@(z) bargaining_nash_product(z,channel,2,da_payoffs,bundles,bargaining_parameters(channel,2),new_input_costs,regulation_option,preferences,conglomerate_parameters), @(z) d_bargaining_nash_product(z,channel,2,da_payoffs,bundles,bargaining_parameters(channel,2),new_input_costs,regulation_option,preferences,conglomerate_parameters),[],[],-Inf,Inf, 'NP', current_input_cost(channel,2));
    prob.KNITRO.options.XTOL=1e-6;
    prob.KNITRO.options.ALG = 3;
    prob.PriLevOpt = 0; % Print one line each iteration
    prob.KNITRO.options.HESSOPT = 3;
    res = tomRun('knitro', prob);
    new_input_costs(channel,2)=res.x_k;
     
     
     elseif (regulation_option==2 ||  regulation_option==3)
     new_input_costs(conglomerate_groups{channel_to_conglomerate(channel)},2)=fminsearchcon(@(z) bargaining_nash_product(z,conglomerate_groups{channel_to_conglomerate(channel)}(1),2,da_payoffs,bundles,bargaining_parameters(channel,2),new_input_costs,regulation_option,preferences,conglomerate_parameters),new_input_costs(conglomerate_groups{channel_to_conglomerate(channel)},2),zeros(length(conglomerate_groups{channel_to_conglomerate(channel)}),1),[],[],[],[],optimization_options);     
     elseif (regulation_option==4)
         
   % new_input_costs(conglomerate_groups{channel_to_conglomerate(channel)},2)=fminsearchcon(@(z) bargaining_nash_product(z,conglomerate_groups{channel_to_conglomerate(channel)}(1),2,da_payoffs,bundles,bargaining_parameters(channel,2),new_input_costs,regulation_option,preferences,conglomerate_parameters),new_input_costs(conglomerate_groups{channel_to_conglomerate(channel)},2),-2+zeros(length(conglomerate_groups{channel_to_conglomerate(channel)}),1),[],[],[],[],optimization_options);     
         
     internal_bargaining_tolerance=1;
     while (internal_bargaining_tolerance>1e-2)    
     use_old_costs=new_input_costs(conglomerate_groups{channel_to_conglomerate(channel)},2);
     for i=1:length(conglomerate_groups{channel_to_conglomerate(channel)})
         new_input_costs(conglomerate_groups{channel_to_conglomerate(channel)}(i),2)=fminsearch(@(z) bargaining_nash_product(z,conglomerate_groups{channel_to_conglomerate(channel)}(i),2,da_payoffs,bundles,bargaining_parameters(channel,2),new_input_costs,regulation_option,preferences,conglomerate_parameters),new_input_costs(conglomerate_groups{channel_to_conglomerate(channel)}(i),2),optimization_options);
     end
     internal_bargaining_tolerance=max(abs(new_input_costs(conglomerate_groups{channel_to_conglomerate(channel)},2)-use_old_costs));
     disp([new_input_costs(conglomerate_groups{channel_to_conglomerate(channel)},2) use_old_costs])
     disp(['internal tol small cable:' num2str(internal_bargaining_tolerance)])
     end
         
     end
    end

disp('Small Cable Negotiations Complete')

    % Compute disagreement payoffs for directv/channel
    da_bundles=bundles;
    if (conglomerate==0)
    da_bundles(channel,3)=0;
    else
    da_bundles(conglomerate_groups{channel_to_conglomerate(channel)},3)=0;
    end
    da_payoffs=bargaining_disagreement_payoffs(channel,3,da_bundles,new_input_costs,regulation_option,preferences,conglomerate_parameters);
    % Compute Nash bargaining input cost for directv/channel    
    if (conglomerate==0)
    bundles(channel,3)=1;
    else
    bundles(conglomerate_groups{channel_to_conglomerate(channel)},3)=1;
    end    
    
    if (conglomerate==0)
    new_input_costs(channel,3)=fminsearch(@(z) bargaining_nash_product(z,channel,3,da_payoffs,bundles,bargaining_parameters(channel,3),new_input_costs,regulation_option,preferences,conglomerate_parameters),current_input_cost(channel,3),optimization_options);
    else
     if (regulation_option==1)
         
%      new_input_costs(channel,3)=fminsearch(@(z) bargaining_nash_product(z,channel,3,da_payoffs,bundles,bargaining_parameters(channel,3),new_input_costs,regulation_option,preferences,conglomerate_parameters),current_input_cost(channel,3),optimization_options);
    prob = conAssign(@(z) bargaining_nash_product(z,channel,3,da_payoffs,bundles,bargaining_parameters(channel,3),new_input_costs,regulation_option,preferences,conglomerate_parameters), @(z) d_bargaining_nash_product(z,channel,3,da_payoffs,bundles,bargaining_parameters(channel,3),new_input_costs,regulation_option,preferences,conglomerate_parameters),[],[],-Inf,Inf, 'NP', current_input_cost(channel,3));
    prob.KNITRO.options.XTOL=1e-6;
    prob.KNITRO.options.ALG = 3;
    prob.PriLevOpt = 0; % Print one line each iteration
    prob.KNITRO.options.HESSOPT = 3;
    res = tomRun('knitro', prob);
    new_input_costs(channel,3)=res.x_k;
     
     
     elseif (regulation_option==2 ||  regulation_option==3)
     new_input_costs(conglomerate_groups{channel_to_conglomerate(channel)},3)=fminsearchcon(@(z) bargaining_nash_product(z,conglomerate_groups{channel_to_conglomerate(channel)}(1),3,da_payoffs,bundles,bargaining_parameters(channel,3),new_input_costs,regulation_option,preferences,conglomerate_parameters),new_input_costs(conglomerate_groups{channel_to_conglomerate(channel)},3),zeros(length(conglomerate_groups{channel_to_conglomerate(channel)}),1),[],[],[],[],optimization_options);     
     elseif (regulation_option==4)
     internal_bargaining_tolerance=1;
     while (internal_bargaining_tolerance>1e-2)    
     use_old_costs=new_input_costs(conglomerate_groups{channel_to_conglomerate(channel)},3);
     for i=1:length(conglomerate_groups{channel_to_conglomerate(channel)})
        new_input_costs(conglomerate_groups{channel_to_conglomerate(channel)}(i),3)=fminsearch(@(z) bargaining_nash_product(z,conglomerate_groups{channel_to_conglomerate(channel)}(i),3,da_payoffs,bundles,bargaining_parameters(channel,3),new_input_costs,regulation_option,preferences,conglomerate_parameters),new_input_costs(conglomerate_groups{channel_to_conglomerate(channel)}(i),3),optimization_options);
     end
     internal_bargaining_tolerance=max(abs(new_input_costs(conglomerate_groups{channel_to_conglomerate(channel)},3)-use_old_costs));
     disp([new_input_costs(conglomerate_groups{channel_to_conglomerate(channel)},3) use_old_costs])
     disp(['internal tol directv:' num2str(internal_bargaining_tolerance)])
     end
     
     end
    end
    
disp('DirecTV Negotiations Complete')

    % Compute disagreement payoffs for dish/channel
    da_bundles=bundles;
    if (conglomerate==0)
    da_bundles(channel,4)=0;
    else
    da_bundles(conglomerate_groups{channel_to_conglomerate(channel)},4)=0;
    end
    da_payoffs=bargaining_disagreement_payoffs(channel,4,da_bundles,new_input_costs,regulation_option,preferences,conglomerate_parameters);
    % Compute Nash bargaining input cost for dish/channel    
    if (conglomerate==0)
    bundles(channel,4)=1;
    else
    bundles(conglomerate_groups{channel_to_conglomerate(channel)},4)=1;
    end    
    
    if (conglomerate==0)
    new_input_costs(channel,4)=fminsearch(@(z) bargaining_nash_product(z,channel,4,da_payoffs,bundles,bargaining_parameters(channel,4),new_input_costs,regulation_option,preferences,conglomerate_parameters),current_input_cost(channel,4),optimization_options);
    else
     if (regulation_option==1)
         
%      new_input_costs(channel,4)=fminsearch(@(z) bargaining_nash_product(z,channel,4,da_payoffs,bundles,bargaining_parameters(channel,4),new_input_costs,regulation_option,preferences,conglomerate_parameters),current_input_cost(channel,4),optimization_options);
    prob = conAssign(@(z) bargaining_nash_product(z,channel,4,da_payoffs,bundles,bargaining_parameters(channel,4),new_input_costs,regulation_option,preferences,conglomerate_parameters), @(z) d_bargaining_nash_product(z,channel,4,da_payoffs,bundles,bargaining_parameters(channel,4),new_input_costs,regulation_option,preferences,conglomerate_parameters),[],[],-Inf,Inf, 'NP', current_input_cost(channel,4));
    prob.KNITRO.options.XTOL=1e-6;
    prob.KNITRO.options.ALG = 3;
    prob.PriLevOpt = 0; % Print one line each iteration
    prob.KNITRO.options.HESSOPT = 3;
    res = tomRun('knitro', prob);
    new_input_costs(channel,4)=res.x_k;
          
     
     elseif (regulation_option==2 ||  regulation_option==3)
     new_input_costs(conglomerate_groups{channel_to_conglomerate(channel)},4)=fminsearchcon(@(z) bargaining_nash_product(z,conglomerate_groups{channel_to_conglomerate(channel)}(1),4,da_payoffs,bundles,bargaining_parameters(channel,4),new_input_costs,regulation_option,preferences,conglomerate_parameters),new_input_costs(conglomerate_groups{channel_to_conglomerate(channel)},4),zeros(length(conglomerate_groups{channel_to_conglomerate(channel)}),1),[],[],[],[],optimization_options);     
     elseif (regulation_option==4)  
     internal_bargaining_tolerance=1;
     while (internal_bargaining_tolerance>1e-2)    
     use_old_costs=new_input_costs(conglomerate_groups{channel_to_conglomerate(channel)},4);
     for i=1:length(conglomerate_groups{channel_to_conglomerate(channel)})
        new_input_costs(conglomerate_groups{channel_to_conglomerate(channel)}(i),4)=fminsearch(@(z) bargaining_nash_product(z,conglomerate_groups{channel_to_conglomerate(channel)}(i),4,da_payoffs,bundles,bargaining_parameters(channel,4),new_input_costs,regulation_option,preferences,conglomerate_parameters),new_input_costs(conglomerate_groups{channel_to_conglomerate(channel)}(i),4),optimization_options);
     end
     internal_bargaining_tolerance=max(abs(new_input_costs(conglomerate_groups{channel_to_conglomerate(channel)},4)-use_old_costs));
     disp([new_input_costs(conglomerate_groups{channel_to_conglomerate(channel)},4) use_old_costs])
     disp(['internal tol dish:' num2str(internal_bargaining_tolerance)])
     end         
         
     end
    end
        
disp('Dish Negotiations Complete')

        
    if (conglomerate==0)
%     track_negotiations(end+1,:)=new_input_costs(channel,:);
    bargaining_tolerance=max(abs(current_input_cost(channel,:)-new_input_costs(channel,:)));
    else
%     track_negotiations(end+1,:)=new_input_costs(channel,:);
    bargaining_tolerance=max(max(abs(current_input_cost(conglomerate_groups{channel_to_conglomerate(channel)},:)-new_input_costs(conglomerate_groups{channel_to_conglomerate(channel)},:))));        
    end
    current_input_cost=new_input_costs;
    disp(['Bargaining Tolerance: ', num2str(bargaining_tolerance)])
    disp(['Current Costs: ', num2str(new_input_costs(channel,:))])
    
    load track_bargaining_equilibrium
    track_barg_tol(end+1)=bargaining_tolerance;
    track_costs(:,:,end+1)=new_input_costs;
    save track_bargaining_equilibrium track_barg_tol track_costs
    
end

