clear all

load last_iteration4
load elasticity_computations

% import tierno 
tierno=csvread('data/tierno.csv');

alpha_i=all_parameters(end);
beta_p=-.45;
s=bundle_market_shares;

%Compute implied marginal costs

    [bundle_shares_by_household satellite_shares_by_household]=market_shares(deltas,interactions,X,simulations,same_market);
    
    [DELTA DELTA_i]=create_DELTA_matrix(alpha_i,income_matrix,bundle_shares_by_household,same_market_min_max_index,mu_eps);
    DELTA=sparse(DELTA);
    DELTA_i=sparse(DELTA_i);
    
        invert_DELTA=((DELTA.*(beta_p)+DELTA_i).*mu_eps);

        markup=invert_DELTA\bundle_market_shares;
        mc_hat = bundle_prices+markup;
        test=zeros(length(bundle_prices),1);
        for k=1:length(bundle_prices)
            
            test(k)= (bundle_prices(k)/s(k))*invert_DELTA(k,k);
        end

% for each bundle, go through and find each elasticity for the bundles it
% competes against
elasticity=zeros(length(X(:,end)),10);
sat_elasticity=zeros(length(X(:,end)),10);
outside_elasticity=zeros(length(X(:,end)),10);
for j=1:length(X(:,1))

    %pick off other bundles in market
bundle_indices = find(dma_order(:,1)==dma_order(j,1) & dma_order(:,2)==dma_order(j,2) & dma_order(:,3)==dma_order(j,3));
beta_i = beta_p + alpha_i.*income_matrix(j,:);

for i=1:length(bundle_indices)

    %wrt other cable bundles price
    if (bundle_indices(i)==j)
        for k=1:(simulations)
        DSIM(k)=((predicted_share_numerator(bundle_indices(i),k)./predicted_share_denominator(bundle_indices(i),k))-(predicted_share_numerator(bundle_indices(i),k)./predicted_share_denominator(bundle_indices(i),k)).^2);
        end
        elasticity(j,tierno(bundle_indices(i)))=mean((beta_i).*mu_eps.*DSIM)*(X_small(j,end)/s(j));
    else
        for k=1:(simulations)
        DSIM(k)=((predicted_share_numerator(bundle_indices(i),k)./predicted_share_denominator(bundle_indices(i),k)).*(predicted_share_numerator(j,k)./predicted_share_denominator(j,k)));
        end        
        elasticity(j,tierno(bundle_indices(i)))=-mean( (beta_i).*mu_eps.*DSIM)*(X_small(bundle_indices(i),end)/s(j));        
    end

end

%wrt to satellite price
       
for k=1:(simulations)
DSIM(k)=((predicted_share_numerator(j,k)./predicted_share_denominator(j,k)).*(satellite_deltas_matrix(j,k)./predicted_share_denominator(j,k)));
end        
elasticity(j,10)=-mean((beta_i ).*mu_eps.*DSIM)*(satellite_prices(2008-dma_order(j,1))/s(j));        
sat_elasticity(j,tierno(j))=-mean((beta_i).*mu_eps.*DSIM)*(X(j,end)/satellite_share(j));        

for k=1:(simulations)
    DSIM(k)=((predicted_share_numerator(j,k)./predicted_share_denominator(j,k)).*(1./predicted_share_denominator(j,k)));
end   
outside_elasticity(j,tierno(j))=-mean((beta_i ).*mu_eps.*DSIM)*(X(j,end)/(1-satellite_share(j)-s(j)));        

%satellite own price
       
for k=1:(simulations)
        DSIM(k)=((satellite_deltas_matrix(j,k)./predicted_share_denominator(j,k))-(satellite_deltas_matrix(j,k)./predicted_share_denominator(j,k)).^2);
end        
sat_elasticity(j,10)=mean((beta_i ).*mu_eps.*DSIM)*(satellite_prices(2008-dma_order(j,1))/satellite_share(j));        

for k=1:(simulations)
    DSIM(k)=((satellite_deltas_matrix(j,k)./predicted_share_denominator(j,k)).*(1./predicted_share_denominator(j,k)));
end   
outside_elasticity(j,10)=-mean((beta_i ).*mu_eps.*DSIM)*(satellite_prices(2008-dma_order(j,1))/(1-satellite_share(j)-s(j)));        



end



[median(elasticity(tierno==1 & dma_order(:,7)==2,1)) median(elasticity(tierno==1 & dma_order(:,7)==2,2)) median(elasticity(tierno==1 & dma_order(:,7)==3,6)) median(elasticity(tierno==1 & dma_order(:,7)==3,10))]
[mean(elasticity(tierno==1 & dma_order(:,7)==2,1)) mean(elasticity(tierno==1 & dma_order(:,7)==2,2)) mean(elasticity(tierno==1 & dma_order(:,7)==3,6)) mean(elasticity(tierno==1 & dma_order(:,7)==3,10))]
[std(elasticity(tierno==1 & dma_order(:,7)==2,1)) std(elasticity(tierno==1 & dma_order(:,7)==2,2)) std(elasticity(tierno==1 & dma_order(:,7)==3,6)) std(elasticity(tierno==1 & dma_order(:,7)==3,10))]



[median(elasticity(tierno==1 & dma_order(:,7)==3,1)) median(elasticity(tierno==1 & dma_order(:,7)==3,2)) median(elasticity(tierno==1 & dma_order(:,7)==3,6)) median(elasticity(tierno==1 & dma_order(:,7)==3,10))]
[mean(elasticity(tierno==1 & dma_order(:,7)==3,1)) mean(elasticity(tierno==1 & dma_order(:,7)==3,2)) mean(elasticity(tierno==1 & dma_order(:,7)==3,6)) mean(elasticity(tierno==1 & dma_order(:,7)==3,10))]
[std(elasticity(tierno==1 & dma_order(:,7)==3,1)) std(elasticity(tierno==1 & dma_order(:,7)==3,2)) std(elasticity(tierno==1 & dma_order(:,7)==3,6)) std(elasticity(tierno==1 & dma_order(:,7)==3,10))]

[median(elasticity(tierno==2 & dma_order(:,7)==3,1)) median(elasticity(tierno==2 & dma_order(:,7)==3,2)) median(elasticity(tierno==2 & dma_order(:,7)==3,6)) median(elasticity(tierno==2 & dma_order(:,7)==3,10))]
[mean(elasticity(tierno==2 & dma_order(:,7)==3,1)) mean(elasticity(tierno==2 & dma_order(:,7)==3,2)) mean(elasticity(tierno==2 & dma_order(:,7)==3,6)) mean(elasticity(tierno==2 & dma_order(:,7)==3,10))]
[std(elasticity(tierno==2 & dma_order(:,7)==3,1)) std(elasticity(tierno==2 & dma_order(:,7)==3,2)) std(elasticity(tierno==2 & dma_order(:,7)==3,6)) std(elasticity(tierno==2 & dma_order(:,7)==3,10))]

[median(elasticity(tierno==6 & dma_order(:,7)==3,1)) median(elasticity(tierno==6 & dma_order(:,7)==3,2)) median(elasticity(tierno==6 & dma_order(:,7)==3,6)) median(elasticity(tierno==6 & dma_order(:,7)==3,10))]
[mean(elasticity(tierno==6 & dma_order(:,7)==3,1)) mean(elasticity(tierno==6 & dma_order(:,7)==3,2)) mean(elasticity(tierno==6 & dma_order(:,7)==3,6)) mean(elasticity(tierno==6 & dma_order(:,7)==3,10))]
[std(elasticity(tierno==6 & dma_order(:,7)==3,1)) std(elasticity(tierno==6 & dma_order(:,7)==3,2)) std(elasticity(tierno==6 & dma_order(:,7)==3,6)) std(elasticity(tierno==6 & dma_order(:,7)==3,10))]


[median(sat_elasticity(dma_order(:,7)==3 & sat_elasticity(:,1)~=0,1)) median(sat_elasticity(dma_order(:,7)==3 & sat_elasticity(:,2)~=0,2)) median(sat_elasticity(dma_order(:,7)==3 & sat_elasticity(:,6)~=0,6)) median(sat_elasticity(dma_order(:,7)==3,10))]
[mean(sat_elasticity(dma_order(:,7)==3  & sat_elasticity(:,1)~=0,1)) mean(sat_elasticity(dma_order(:,7)==3 & sat_elasticity(:,2)~=0,2)) mean(sat_elasticity(dma_order(:,7)==3 & sat_elasticity(:,6)~=0,6)) mean(sat_elasticity(dma_order(:,7)==3,10))]
[std(sat_elasticity(dma_order(:,7)==3 & sat_elasticity(:,1)~=0,1)) std(sat_elasticity(dma_order(:,7)==3 & sat_elasticity(:,2)~=0,2)) std(sat_elasticity(dma_order(:,7)==3 & sat_elasticity(:,6)~=0,6)) std(sat_elasticity(dma_order(:,7)==3,10))]

mc=mc_hat;
[mean(mc) median(mc) std(mc)
mean(mc(tierno==1)) median(mc(tierno==1)) std(mc(tierno==1))
mean(mc(tierno==2)) median(mc(tierno==2)) std(mc(tierno==2))
mean(mc(tierno==6)) median(mc(tierno==6)) std(mc(tierno==6))];

[mean(mc(mc>-50)) median(mc(mc>-50)) std(mc(mc>-50))
mean(mc(tierno==1 & mc>-50)) median(mc(tierno==1 & mc>-50)) std(mc(tierno==1 & mc>-50))
mean(mc(tierno==2 & mc>-50)) median(mc(tierno==2 & mc>-50)) std(mc(tierno==2 & mc>-50))
mean(mc(tierno==6 & mc>-50)) median(mc(tierno==6 & mc>-50)) std(mc(tierno==6 & mc>-50))];

[median(bundle_prices(:,end)) median(mc) median(bundle_prices(:,end)./mc)
median(bundle_prices(tierno==1,end)) median(mc(tierno==1)) median(bundle_prices(tierno==1,end)./mc(tierno==1))
median(bundle_prices(tierno==2 & dma_order(:,7)==3,end)) median(mc(tierno==2 & dma_order(:,7)==3)) median(bundle_prices(tierno==2 & dma_order(:,7)==3,end)./mc(tierno==2 & dma_order(:,7)==3))
median(bundle_prices(tierno==6 & dma_order(:,7)==3,end)) median(mc(tierno==6 & dma_order(:,7)==3)) median(bundle_prices(tierno==6 & dma_order(:,7)==3,end)./mc(tierno==6 & dma_order(:,7)==3))];


[median(outside_elasticity(tierno==1 & dma_order(:,7)==3,1)) std(outside_elasticity(tierno==1 & dma_order(:,7)==3,1))
 median(elasticity(tierno==1 & dma_order(:,7)==3,1)) std(elasticity(tierno==1 & dma_order(:,7)==3,1))
 median(elasticity(tierno==1 & dma_order(:,7)==3,2)) std(elasticity(tierno==1 & dma_order(:,7)==3,2))
 median(elasticity(tierno==1 & dma_order(:,7)==3,6)) std(elasticity(tierno==1 & dma_order(:,7)==3,6))
 median(elasticity(tierno==1 & dma_order(:,7)==3,10)) std(elasticity(tierno==1 & dma_order(:,7)==3,10))];

[median(outside_elasticity(tierno==2 & dma_order(:,7)==3,2)) std(outside_elasticity(tierno==2 & dma_order(:,7)==3,2))
 median(elasticity(tierno==2 & dma_order(:,7)==3,1)) std(elasticity(tierno==2 & dma_order(:,7)==3,1))
 median(elasticity(tierno==2 & dma_order(:,7)==3,2)) std(elasticity(tierno==2 & dma_order(:,7)==3,2))
 median(elasticity(tierno==2 & dma_order(:,7)==3,6)) std(elasticity(tierno==2 & dma_order(:,7)==3,6))
 median(elasticity(tierno==2 & dma_order(:,7)==3,10)) std(elasticity(tierno==2 & dma_order(:,7)==3,10))];

[median(outside_elasticity(tierno==6 & dma_order(:,7)==3,6)) std(outside_elasticity(tierno==6 & dma_order(:,7)==3,6))
 median(elasticity(tierno==6 & dma_order(:,7)==3,1)) std(elasticity(tierno==6 & dma_order(:,7)==3,1))
 median(elasticity(tierno==6 & dma_order(:,7)==3,2)) std(elasticity(tierno==6 & dma_order(:,7)==3,2))
 median(elasticity(tierno==6 & dma_order(:,7)==3,6)) std(elasticity(tierno==6 & dma_order(:,7)==3,6))
 median(elasticity(tierno==6 & dma_order(:,7)==3,10)) std(elasticity(tierno==6 & dma_order(:,7)==3,10))];

[median(outside_elasticity(tierno==1 & dma_order(:,7)==3,10)) std(outside_elasticity(tierno==1 & dma_order(:,7)==3,10))
 median(sat_elasticity(tierno==1 & dma_order(:,7)==3,1)) std(sat_elasticity(tierno==1 & dma_order(:,7)==3,1))
 median(sat_elasticity(tierno==2 & dma_order(:,7)==3,2)) std(sat_elasticity(tierno==2 & dma_order(:,7)==3,2))
 median(sat_elasticity(tierno==6 & dma_order(:,7)==3,6)) std(sat_elasticity(tierno==6 & dma_order(:,7)==3,6))
 median(sat_elasticity(tierno==1 & dma_order(:,7)==3,10)) std(sat_elasticity(tierno==1 & dma_order(:,7)==3,10))];

