#include <fintrf.h>
!
!     Matlab call : [d_log_v_ij d_log_v_ij_satellite d_time_watched d_time_watched_satelled d_outside_good_utility]=find_nonlinear_jacobian(Pi_matrix,simulations_vector,marginal_distribution_parameters,rho,copula_parameter,market_demographics_draws,zero_out_draws,unobservable_draws,parametric_family_of_marginal_distributions,copula_parametric_family,X,satellite_channels,market_representative,dma_id,market_id,year_id,mu_eps,parameter_type,index_1,index_2,zeroed_out, pre_gamma, gamma_cable, gamma_satellite, bundle_total_gamma, bundle_total_gamma_satellite,v_ij, v_ij_satellite, time_watched, time_watched_satellite, pre_logged_utility, pre_logged_utility_satellite, copula_deriv, marginal_deriv)
!
!       Pi_matrix                                   (number_of_channels+1) x 7
!       simulations_vector                          1 x simulations
!       marginal_distribution_parameters            (number_of_channels+1) x 1
!       rho                                         (number_of_channels+1) x 8
!       copula_parameter                            (number_of_channels+1) x (number_of_channels+1)
!       market_demographics                         210 x 110 x simulations x 7
!       zero_out_draws                              (number_of_channels+1) x simulations x number_of_bundles
!       unobservable_draws                          (number_of_channels+1) x simulations x number_of_bundles
!       parametric_family_of_marginal_distributions scalar
!       copula_parametric_family                    scalar
!       X                                           number_of_bundles x (number_of_channels+1)
!       satellite_channels                          11 x number_of_channels
!       market_representative                       number_of_bundles x 1
!       dma_id                                      number_of_bundles x 1
!       market_id                                   number_of_bundles x 1
!       year_id                                     number_of_bundles x 1
!       mu_eps                                      scalar
!       parameter_type                              scalar (1=copula,2=Pi,3=marginal_distribution)
!       index_1                                      scalar
!       index_2                                      scalar
!       zeroed_out                                  number_of_channels x simulations x number_of_bundles
!       pre_gamma                                   number_of_channels x simulations x number_of_bundles
!       gamma_cable                                 number_of_channels x simulations x number_of_bundles
!       gamma_satellite                             number_of_channels x simulations x number_of_bundles
!       bundle_total_gamma                          simulations x number_of_bundles
!       bundle_total_gamma_satellite                simulations x number_of_bundles
!       v_ij                                        number_of_bundles x simulations
!       v_ij_satellite                              number_of_bundles x simulations
!       time_watched                                number_of_channels x simulations x number_of_bundles
!       time_watched_satellite                      number_of_channels x simulations x number_of_bundles
!       outside_good_utility                        number_of_bundles x simulations

!       Output
!       d_log_v_ij                                        number_of_bundles x simulations
!       d_log_v_ij_satellite                              number_of_bundles x simulations
!       d_time_watched                                number_of_channels x simulations x number_of_bundles
!       d_time_watched_satellite                      number_of_channels x simulations x number_of_bundles
!       d_outside_good_utility                        number_of_bundles x simulations

!     Gateway function to import matlab arrays, define outputs, error checking, and call numerical subroutines

      subroutine mexfunction(nlhs,plhs,nrhs,prhs)
      implicit none
      integer nlhs,nrhs, time_watched_dimensions(3)
      mwpointer plhs(*),prhs(*)
      mwpointer mxgetpr, mxcreatecellarray, mxcreatedoublematrix, mxcreatedoublescalar, mxCreateNumericArray, mxClassIDFromClassName
      mwpointer Pi_matrix,simulations_vector,marginal_distribution_parameters,rho,copula_parameter,market_demographics,zero_out,unobservable_draws,parametric_family_of_marginal_distributions,copula_parametric_family,X,satellite_channels,market_representative
      mwpointer dma_id, market_id, year_id, d_log_v_ij, d_log_v_ij_satellite, d_time_watched, d_time_watched_satellite, d_outside_good_utility, mu_eps, parameter_type, index_1, index_2
      mwpointer zeroed_out, pre_gamma, gamma_cable, gamma_satellite, bundle_total_gamma, bundle_total_gamma_satellite
      mwpointer v_ij, v_ij_satellite, time_watched, time_watched_satellite, pre_logged_utility, pre_logged_utility_satellite, copula_deriv, marginal_deriv
      mwsize mxgetm, mxgetn
      mwsize number_of_channels, number_of_bundles, simulations
    
!     RHS parameters
      
      Pi_matrix=mxgetpr(prhs(1)) 
      simulations_vector=  mxgetpr(prhs(2)) 
      marginal_distribution_parameters=mxgetpr(prhs(3)) 
      rho=mxgetpr(prhs(4)) 
      copula_parameter=mxgetpr(prhs(5)) 
      market_demographics=mxgetpr(prhs(6)) 
      zero_out=mxgetpr(prhs(7))  
      unobservable_draws=mxgetpr(prhs(8)) 
      parametric_family_of_marginal_distributions=mxgetpr(prhs(9)) 
      copula_parametric_family=mxgetpr(prhs(10))                    
      X=mxgetpr(prhs(11))                                           
      satellite_channels=mxgetpr(prhs(12))                                                         
      market_representative=mxgetpr(prhs(13))                       
      dma_id=mxgetpr(prhs(14))                       
      market_id=mxgetpr(prhs(15))            
      year_id=mxgetpr(prhs(16))           
      mu_eps=mxgetpr(prhs(17))   
      parameter_type=mxgetpr(prhs(18))   
      index_1=mxgetpr(prhs(19))   
      index_2=mxgetpr(prhs(20))   
      zeroed_out = mxgetpr(prhs(21)) 
      pre_gamma = mxgetpr(prhs(22)) 
      gamma_cable = mxgetpr(prhs(23)) 
      gamma_satellite = mxgetpr(prhs(24)) 
      bundle_total_gamma = mxgetpr(prhs(25)) 
      bundle_total_gamma_satellite = mxgetpr(prhs(26)) 
      v_ij = mxgetpr(prhs(27)) 
      v_ij_satellite = mxgetpr(prhs(28)) 
      time_watched = mxgetpr(prhs(29)) 
      time_watched_satellite = mxgetpr(prhs(30)) 
      pre_logged_utility = mxgetpr(prhs(31)) 
      pre_logged_utility_satellite = mxgetpr(prhs(32)) 
      copula_deriv = mxgetpr(prhs(33)) 
      marginal_deriv = mxgetpr(prhs(34)) 

        number_of_channels=mxgetm(prhs(1))
        simulations=mxgetn(prhs(2))
        number_of_bundles=mxgetm(prhs(15))

        time_watched_dimensions(1)=number_of_channels
        time_watched_dimensions(2)=simulations
        time_watched_dimensions(3)=number_of_bundles

      PLHS(1) = MXCREATEDOUBLEMATRIX(number_of_bundles,simulations,0)
      d_log_v_ij = MXGETPR(PLHS(1))
      PLHS(2) = MXCREATEDOUBLEMATRIX(number_of_bundles,simulations,0)
      d_log_v_ij_satellite = MXGETPR(PLHS(2))
      PLHS(3) = mxCreateNumericArray(3,time_watched_dimensions, mxClassIDFromClassName('double'), 0)
      d_time_watched = MXGETPR(PLHS(3))
      PLHS(4) = mxCreateNumericArray(3,time_watched_dimensions, mxClassIDFromClassName('double'), 0)
      d_time_watched_satellite = MXGETPR(PLHS(4))
      PLHS(5) = MXCREATEDOUBLEMATRIX(number_of_bundles,simulations,0)
      d_outside_good_utility = MXGETPR(PLHS(5))

      call find_nonlinear_jacobian(%val(d_log_v_ij),%val(d_log_v_ij_satellite),%val(d_time_watched),%val(d_time_watched_satellite),%val(d_outside_good_utility),%val(zeroed_out),%val(pre_gamma),%val(gamma_cable),%val(gamma_satellite),%val(bundle_total_gamma),%val(bundle_total_gamma_satellite),%val(v_ij),%val(v_ij_satellite),%val(time_watched),%val(time_watched_satellite),%val(pre_logged_utility),%val(pre_logged_utility_satellite),%val(copula_deriv),%val(marginal_deriv),%val(marginal_distribution_parameters),%val(Pi_matrix),%val(copula_parameter),%val(rho),%val(unobservable_draws),%val(market_demographics),%val(zero_out),%val(dma_id),%val(market_id),%val(year_id),%val(X),%val(satellite_channels),%val(mu_eps),%val(parameter_type),%val(index_1),%val(index_2),number_of_channels,simulations,number_of_bundles)
                         
      return
      end


        subroutine find_nonlinear_jacobian(d_log_v_ij,d_log_v_ij_satellite,d_time_watched,d_time_watched_satellite,d_outside_good_utility,zeroed_out,pre_gamma,gamma_cable,gamma_satellite,bundle_total_gamma,bundle_total_gamma_satellite,v_ij,v_ij_satellite,time_watched,time_watched_satellite,pre_logged_utility,pre_logged_utility_satellite,copula_deriv,marginal_deriv,marginal_distribution_parameters,Pi_matrix,copula_parameter,rho,unobservable_draws,market_demographics,zero_out,dma_id,market_id,year_id,X,satellite_channels,mu_eps,parameter_type,index_1,index_2,number_of_channels,simulations,number_of_bundles)
        include 'link_fnl_static.h'
        implicit none

        mwsize number_of_channels, simulations, number_of_bundles
        integer i, j, k, n
        double precision dma_id(number_of_bundles), market_id(number_of_bundles), year_id(number_of_bundles), adjusted_draws(number_of_channels,simulations), pre_interactions(number_of_channels,simulations), pre_unattributable_draws(number_of_channels,simulations)
        integer i_dma_id(number_of_bundles), i_market_id(number_of_bundles), i_year_id(number_of_bundles)
        double precision marginal_distribution_parameters(number_of_channels), Pi_matrix(number_of_channels,7), copula_parameter(number_of_channels,number_of_channels), X(number_of_bundles,number_of_channels), satellite_channels(11,number_of_channels-1)
        double precision unobs_draws_matrix(number_of_channels,simulations), pre_demographic_draw(number_of_channels,simulations), demographics_vector(7)
        double precision rho(number_of_channels,8), market_demographics(210,110,simulations,7),  zero_out(number_of_channels,simulations,number_of_bundles), unobservable_draws(number_of_channels,simulations,number_of_bundles)
        double precision d_pre_gamma(number_of_channels,simulations),d_gamma_cable(number_of_channels,simulations), d_gamma_satellite(number_of_channels,simulations)
        double precision d_bundle_total_gamma(simulations), d_bundle_total_gamma_satellite(simulations)
        double precision d_v_ij(number_of_bundles,simulations), d_v_ij_satellite(number_of_bundles,simulations), d_outside_good_utility(number_of_bundles,simulations)
        double precision logged_utility(number_of_channels), logged_utility_satellite(number_of_channels)
        double precision d_logged_utility(number_of_channels), d_logged_utility_satellite(number_of_channels)
        double precision d_time_watched(number_of_channels,simulations,number_of_bundles), d_time_watched_satellite(number_of_channels,simulations,number_of_bundles)
        double precision mu_eps, parameter_type, index_1, index_2
        double precision pre_gamma(number_of_channels,simulations,number_of_bundles), zeroed_out(number_of_channels,simulations,number_of_bundles), gamma_cable(number_of_channels,simulations,number_of_bundles), gamma_satellite(number_of_channels,simulations,number_of_bundles)
        double precision bundle_total_gamma(number_of_bundles,simulations), bundle_total_gamma_satellite(number_of_bundles,simulations)
        double precision log_ten_eighty_one
        double precision d_log_v_ij(number_of_bundles,simulations),d_log_v_ij_satellite(number_of_bundles,simulations)
        double precision v_ij(number_of_bundles,simulations), v_ij_satellite(number_of_bundles,simulations), time_watched(number_of_channels,simulations,number_of_bundles), time_watched_satellite(number_of_channels,simulations,number_of_bundles), pre_logged_utility(number_of_channels,simulations,number_of_bundles), pre_logged_utility_satellite(number_of_channels,simulations,number_of_bundles), copula_deriv(number_of_channels,number_of_channels,simulations,number_of_bundles), marginal_deriv(number_of_channels,simulations,number_of_bundles)
        integer i_index_1, i_index_2, i_parameter_type
        integer*4, external :: mexPrintf
        character(len=80) :: line
        INTEGER TID, OMP_GET_THREAD_NUM

        i_dma_id=INT(dma_id)
        i_market_id=INT(market_id)
        i_year_id=INT(year_id)

        i_index_1=INT(index_1)
        i_index_2=INT(index_2)
        
        i_parameter_type=INT(parameter_type)



        ! for each market, bring in random draws and sum them up

!$OMP PARALLEL SHARED(market_demographics,copula_parameter,marginal_distribution_parameters,i_year_id,Pi_matrix,i_parameter_type,i_index_1,i_index_2,zeroed_out,pre_gamma,gamma_cable,gamma_satellite,bundle_total_gamma,bundle_total_gamma_satellite,v_ij,v_ij_satellite,d_log_v_ij,d_log_v_ij_satellite,d_v_ij,d_v_ij_satellite,time_watched,time_watched_satellite,d_time_watched,d_time_watched_satellite,d_outside_good_utility,pre_logged_utility,pre_logged_utility_satellite,copula_deriv,marginal_deriv,mu_eps,X,satellite_channels,number_of_channels,simulations) PRIVATE(j,k,unobs_draws_matrix,adjusted_draws,demographics_vector,pre_interactions,pre_unattributable_draws,pre_demographic_draw,d_logged_utility,d_logged_utility_satellite,d_pre_gamma,d_gamma_cable,d_gamma_satellite,d_bundle_total_gamma,d_bundle_total_gamma_satellite,log_ten_eighty_one,TID), NUM_THREADS(4)
log_ten_eighty_one=log(10081D0)

!$OMP DO SCHEDULE(DYNAMIC,3000)

        
       
        do i=1,number_of_bundles
                       ! unobs_draws_matrix=unobservable_draws(:,:,i)
           do j=1,simulations
                      demographics_vector=market_demographics(i_dma_id(i),i_market_id(i),j,:)
                do k=1,number_of_channels
            
                    
                    if (zeroed_out(k,j,i).ne.1) then
                    
                    d_pre_gamma(k,j)=0

                    else

                    
                    if (i_parameter_type.eq.1) then
                    ! copula parameter (Compute these outside- copula_deriv)
                    if (k.eq.i_index_1) then
                    d_pre_gamma(k,j)=copula_deriv(k,i_index_2,j,i)
                    elseif (k.eq.i_index_2) then
                    d_pre_gamma(k,j)=copula_deriv(k,i_index_1,j,i)
                    else
                    d_pre_gamma(k,j)=0d0
                    end if

                    elseif (i_parameter_type.eq.2) then
                    ! Pi_matrix parameter
                    if (k.eq.i_index_1) then
                    d_pre_gamma(k,j)=demographics_vector(i_index_2)
                    else
                    d_pre_gamma(k,j)=0d0
                    end if

                    elseif (i_parameter_type.eq.3) then

                    if (k.lt.number_of_channels) then
                    ! marginal_distribution_parameter (compute LOG term once outside and pass through- marginal_deriv)
                    if (k.eq.i_index_1) then
                    d_pre_gamma(k,j)=marginal_deriv(k,j,i)
                    else
                    d_pre_gamma(k,j)=0d0
                    end if
                    else
                    d_pre_gamma(k,j)=0d0
                    end if

                    end if
                    end if

                    if (k.lt.number_of_channels) then
                    d_gamma_cable(k,j)=d_pre_gamma(k,j)*X(i,1+k)
                    d_gamma_satellite(k,j)=d_pre_gamma(k,j)*satellite_channels(-1996+i_year_id(i),k)
                    else
                    d_gamma_cable(k,j)=d_pre_gamma(k,j)
                    d_gamma_satellite(k,j)=d_pre_gamma(k,j)
                    end if


                end do 

                d_bundle_total_gamma(j)=SUM(d_gamma_cable(:,j))
                d_bundle_total_gamma_satellite(j)=SUM(d_gamma_satellite(:,j))

                    do k=1,number_of_channels
                    !d_time_watched(k,j,i)=d_gamma_cable(k,j)
                    !d_time_watched_satellite(k,j,i)=d_bundle_total_gamma(j)
                    d_time_watched(k,j,i) = (bundle_total_gamma(i,j)*d_gamma_cable(k,j)-gamma_cable(k,j,i)*d_bundle_total_gamma(j))/(bundle_total_gamma(i,j)*bundle_total_gamma(i,j))
                    d_time_watched_satellite(k,j,i) = (bundle_total_gamma_satellite(i,j)*d_gamma_satellite(k,j)-gamma_satellite(k,j,i)*d_bundle_total_gamma_satellite(j))/(bundle_total_gamma_satellite(i,j)*bundle_total_gamma_satellite(i,j))
                    !compute these logs once at beginning (pre_logged_utility)
                    d_logged_utility(k)=(gamma_cable(k,j,i)*d_gamma_cable(k,j)*d_time_watched(k,j,i))/(1D0+(10080d0*time_watched(k,j,i))) + d_gamma_cable(k,j)*pre_logged_utility(k,j,i)
                    d_logged_utility_satellite(k)=(gamma_satellite(k,j,i)*d_gamma_satellite(k,j)*d_time_watched_satellite(k,j,i))/(1D0+(10080d0*time_watched_satellite(k,j,i))) + d_gamma_satellite(k,j)*pre_logged_utility_satellite(k,j,i)
                    end do

        d_outside_good_utility(i,j)=0d0

        !d_v_ij(i,j)=v_ij(i,j)*mu_eps*(SUM(d_logged_utility)-d_pre_gamma(number_of_channels,j)*log_ten_eighty_one)
        d_v_ij(i,j)=0d0
        d_log_v_ij(i,j)=(SUM(d_logged_utility)-d_pre_gamma(number_of_channels,j)*log_ten_eighty_one)
        !d_v_ij_satellite(i,j)=v_ij_satellite(i,j)*mu_eps*(SUM(d_logged_utility_satellite)-d_pre_gamma(number_of_channels,j)*log_ten_eighty_one)
        d_v_ij_satellite(i,j)=0d0
        d_log_v_ij_satellite(i,j)=(SUM(d_logged_utility_satellite)-d_pre_gamma(number_of_channels,j)*log_ten_eighty_one)
        end do

        
        end do


!$OMP END DO NOWAIT

!$OMP END PARALLEL


           
        return
        end


