function f=full_objective_function(optimizing_parameters,optimizing_indices,all_parameters,u_length,specification,market_demographics_draws,fast_zero_out_draws,fast_unobs_draws_matrix,parametric_family_of_marginal_distributions,copula_parametric_family,X,satellite_channels,dma_order,market_representative,simulations,same_market,sat_dma_rep,system_relative_dma_size,same_dma,homespassed_matrix,match_dmas,mean_demographics,actual_dma_ratings,mean_viewership_by_demographic,covariance_in_hh_viewership,demographic_cume,utility_demographics_matrices,deltas,mu_eps,income_matrix,mediamark_income_moments,bundle_prices,satellite_prices,same_market_min_max_index,same_dma_min_max_index,sys_size_vector,X_small,X_small_hat,bundle_market_shares,satellite_share,homespassed_share,knitro_or_fmin,cume_matrices,normalize,no_display)


tracker=optimizing_parameters;
save tracker tracker

all_parameters(optimizing_indices)=optimizing_parameters;

if (no_display~=1)
% disp(optimizing_parameters)
end

% pause

if (no_display~=1)
tic
end


number_of_bundles=length(X(:,1));
number_of_channels=sum(specification(:,3));

utility_parameters_vector=all_parameters(1:u_length);

pre_rho=all_parameters((u_length+1):(end-1));    
rho=reshape(pre_rho,number_of_channels+1,8);
alpha_i=all_parameters(end);

marginal_distribution_parameters=zeros(number_of_channels+1,1);
pi_index=((number_of_channels+1)*((number_of_channels+1)-1)/2+1);
Pi_matrix=reshape(utility_parameters_vector(pi_index:pi_index-1+(number_of_channels+1)*7),(number_of_channels+1),7);
marginal_distribution_parameters(1:end-1)=utility_parameters_vector(end-number_of_channels+1:end);
pre_copula_parameter=utility_parameters_vector(1:(number_of_channels+1)*((number_of_channels+1)-1)/2);
marginal_distribution_parameters(end)=5;

copula_parameter=zeros(number_of_channels+1,number_of_channels+1);
next=1;
for k=1:number_of_channels+1
   for j=1:k
    if (j~=k)
    copula_parameter(k,j)=pre_copula_parameter(next);
    next=next+1;
    end
   end
end
copula_parameter=copula_parameter+copula_parameter'+eye(number_of_channels+1);
    
simulations_vector=ones(1,simulations);
year_id=dma_order(:,1);
dma_id=dma_order(:,2);
market_id=dma_order(:,3);

prices_matrix=bundle_prices*ones(1,simulations);
satellite_prices_vector=satellite_prices(-1996+dma_order(:,1));
prices_matrix_satellite=satellite_prices_vector*ones(1,simulations);
price_interactions=exp(mu_eps*alpha_i.*income_matrix.*prices_matrix);
price_interactions_satellite=exp(mu_eps*alpha_i.*income_matrix.*prices_matrix_satellite);

[v_ij v_ij_satellite time_watched_cable time_watched_satellite outside_good_utility]=assemble_markets_fortran_mex(Pi_matrix,simulations_vector,marginal_distribution_parameters,rho,copula_parameter,market_demographics_draws,fast_zero_out_draws,fast_unobs_draws_matrix,parametric_family_of_marginal_distributions,copula_parametric_family,X,satellite_channels,market_representative,dma_id,market_id,year_id,mu_eps);

time_watched_cable=permute(time_watched_cable,[3 2 1]);
time_watched_satellite=permute(time_watched_satellite,[3 2 1]);

interactions={v_ij,v_ij_satellite,time_watched_cable,time_watched_satellite,outside_good_utility,price_interactions,price_interactions_satellite};

% Compute deltas

    if (alpha_i<-.3)
        try
            load last_deltas_negative_alpha
        catch
            load last_deltas
        end
    else
         load last_deltas
    end
    
   
    last_deltas=deltas;
    deltas=delta_contraction(last_deltas,v_ij,v_ij_satellite,price_interactions,price_interactions_satellite,X,outside_good_utility,same_market_min_max_index,same_dma_min_max_index,sys_size_vector,bundle_market_shares,satellite_share,mu_eps);


    adjusted_deltas=deltas.^(1/mu_eps);
    y=log(adjusted_deltas(:,1));   

    B_hat_ols = (X_small'*X_small)\(X_small'*y);
    B_hat_no_pricing = (X_small_hat'*X_small_hat)\(X_small_hat'*y);
    beta_p=B_hat_no_pricing(end);
%     beta_p=fminsearch(@(z) find_beta_p(z,y,X_small_hat,bundle_prices,alpha_i),B_hat_no_pricing(end));
    disp(['beta p: ' num2str(beta_p)])

    % for given set of deltas, compute shares for each household

       save last_deltas deltas
   
   [bundle_shares_by_household satellite_shares_by_household]=market_shares(deltas,interactions,X,simulations,same_market);

dma_time_watched=zeros(number_of_bundles,number_of_channels);

hh_viewing=zeros(number_of_bundles,simulations,number_of_channels);

for k=1:number_of_channels

dma_time_watched(:,k)=same_dma*((same_market*mean(time_watched_cable(:,:,k).*bundle_shares_by_household,2)).*(system_relative_dma_size.*(dma_order(:,8)==1)))+sat_dma_rep*mean(time_watched_satellite(:,:,k).*satellite_shares_by_household,2);
hh_viewing(:,:,k)=time_watched_cable(:,:,k).*bundle_shares_by_household + time_watched_satellite(:,:,k).*satellite_shares_by_household ;

end


% save make_faster v_ij v_ij_satellite time_watched_cable time_watched_satellite outside_good_utility dma_time_watched hh_viewing

% Evaluate moment conditions 

    % Mean (Total Hours Watched)/(Total Hours in Week) By Channel (Number of Channels)
    mean_dma_ratings=mean(actual_dma_ratings(match_dmas~=0,:))';
    predicted_dma_ratings=dma_time_watched(dma_order(:,5)==1,:);
    predicted_mean_dma_ratings=mean(predicted_dma_ratings(match_dmas(match_dmas~=0),:))';
    
    % Covariance of DMA (Total Hours Watched)/(Total Hours in Week) with DMA Demographics (Nielsen) (Number of channels*Number of Demographics)
    pre_predicted_nielsen_dma_demographics_covariance=cov([predicted_dma_ratings(match_dmas(match_dmas~=0),:) mean_demographics(match_dmas(match_dmas~=0),[3 15 16 17 18 19 20])]);
    pre_nielsen_dma_demographics_covariance=cov([actual_dma_ratings(match_dmas~=0,:) mean_demographics(match_dmas(match_dmas~=0),[3 15 16 17 18 19 20])]);    
    predicted_nielsen_dma_demographics_covariance=pre_predicted_nielsen_dma_demographics_covariance(1:(end-7),(end-6):end);
    nielsen_dma_demographics_covariance=pre_nielsen_dma_demographics_covariance(1:(end-7),(end-6):end);
    
    % Mean HH Hours Watched by HH Demographics (Mediamark)
    [predicted_mean_viewership_by_demographic channel_viewing_vector channel_viewing_weights]=group_stats(real(utility_demographics_matrices),hh_viewing,homespassed_matrix);
   
    % Cross-Channel Correlation of HH Ratings (Mediamark)
    sum_weights=sum(channel_viewing_weights(:,1));
    m = size(channel_viewing_vector,1);
    xc = channel_viewing_vector - repmat(sum(channel_viewing_vector.*channel_viewing_weights,1)./sum_weights,m,1); % remove weighted mean
    Sigma = (xc' *(channel_viewing_weights.* xc)) ./ sum_weights; % compute weighted covariance
%     sx = sqrt(sum(channel_viewing_weights.*(xc.^2),1) ./ sum_weights); % compute std dev
%     predicted_correlation_in_hh_viewership = Sigma ./ (sx'*sx);    
     predicted_covariance_in_hh_viewership = Sigma;
     
    %Total Market Share Conditional on Income
    total_market_shares=same_market*bundle_shares_by_household + satellite_shares_by_household;
    use_total_market_shares=total_market_shares(dma_order(:,8)==1,:);
    use_income_matrix=income_matrix(dma_order(:,8)==1,:);
    predicted_income_moments = [mean(use_total_market_shares(use_income_matrix<.25)) mean(use_total_market_shares(use_income_matrix>=.25 & use_income_matrix<.45)) mean(use_total_market_shares(use_income_matrix>=.45 & use_income_matrix<.7)) mean(use_total_market_shares(use_income_matrix>=.7 & use_income_matrix<1)) mean(use_total_market_shares(use_income_matrix>=1 & use_income_matrix<1.5)) mean(use_total_market_shares(use_income_matrix>1.5))];
        
    % Fraction of Zero's by Subset of Demographic Groups
    predicted_demographic_cumes=zeros(8,number_of_channels);
    homespassed_matrix=homespassed_share*ones(1,simulations);
    normalize(1)=sum(homespassed_matrix(utility_demographics_matrices(:,:,1)==1 & utility_demographics_matrices(:,:,4)==1 & utility_demographics_matrices(:,:,10)==1));
    normalize(2)=sum(homespassed_matrix(utility_demographics_matrices(:,:,1)==1 & utility_demographics_matrices(:,:,4)==0 & utility_demographics_matrices(:,:,10)==1));
    normalize(3)=sum(homespassed_matrix(utility_demographics_matrices(:,:,1)==1 & utility_demographics_matrices(:,:,4)==0 & utility_demographics_matrices(:,:,10)==0));
    normalize(4)=sum(homespassed_matrix(utility_demographics_matrices(:,:,1)==1 & utility_demographics_matrices(:,:,4)==1 & utility_demographics_matrices(:,:,10)==0));
    normalize(5)=sum(homespassed_matrix(utility_demographics_matrices(:,:,1)==0 & utility_demographics_matrices(:,:,4)==1 & utility_demographics_matrices(:,:,10)==1));
    normalize(6)=sum(homespassed_matrix(utility_demographics_matrices(:,:,1)==0 & utility_demographics_matrices(:,:,4)==0 & utility_demographics_matrices(:,:,10)==1));
    normalize(7)=sum(homespassed_matrix(utility_demographics_matrices(:,:,1)==0 & utility_demographics_matrices(:,:,4)==0 & utility_demographics_matrices(:,:,10)==0));
    normalize(8)=sum(homespassed_matrix(utility_demographics_matrices(:,:,1)==0 & utility_demographics_matrices(:,:,4)==1 & utility_demographics_matrices(:,:,10)==0));

    for k=1:number_of_channels
%     dma_time_watched(:,k)=same_dma*((same_market*mean(time_watched_cable(:,:,k).*bundle_shares_by_household,2)).*(system_relative_dma_size.*(dma_order(:,8)==1)))+sat_dma_rep*mean(time_watched_satellite(:,:,k).*satellite_shares_by_household,2);
%     hh_viewing(:,:,k)=time_watched_cable(:,:,k).*bundle_shares_by_household + time_watched_satellite(:,:,k).*satellite_shares_by_household ;
    hh_cume=(time_watched_cable(:,:,k)>0).*bundle_shares_by_household.*homespassed_matrix + (time_watched_satellite(:,:,k)>0).*satellite_shares_by_household.*homespassed_matrix ;

%     predicted_demographic_cumes(1,k)=sum(hh_cume(utility_demographics_matrices(:,:,1)==1 & utility_demographics_matrices(:,:,4)==1 & utility_demographics_matrices(:,:,10)==1))/ normalize(1);
%     predicted_demographic_cumes(2,k)=sum(hh_cume(utility_demographics_matrices(:,:,1)==1 & utility_demographics_matrices(:,:,4)==0 & utility_demographics_matrices(:,:,10)==1))/ normalize(2);
%     predicted_demographic_cumes(3,k)=sum(hh_cume(utility_demographics_matrices(:,:,1)==1 & utility_demographics_matrices(:,:,4)==0 & utility_demographics_matrices(:,:,10)==0))/ normalize(3);
%     predicted_demographic_cumes(4,k)=sum(hh_cume(utility_demographics_matrices(:,:,1)==1 & utility_demographics_matrices(:,:,4)==1 & utility_demographics_matrices(:,:,10)==0))/ normalize(4);
%     predicted_demographic_cumes(5,k)=sum(hh_cume(utility_demographics_matrices(:,:,1)==0 & utility_demographics_matrices(:,:,4)==1 & utility_demographics_matrices(:,:,10)==1))/ normalize(5);
%     predicted_demographic_cumes(6,k)=sum(hh_cume(utility_demographics_matrices(:,:,1)==0 & utility_demographics_matrices(:,:,4)==0 & utility_demographics_matrices(:,:,10)==1))/ normalize(6);
%     predicted_demographic_cumes(7,k)=sum(hh_cume(utility_demographics_matrices(:,:,1)==0 & utility_demographics_matrices(:,:,4)==0 & utility_demographics_matrices(:,:,10)==0))/ normalize(7);
%     predicted_demographic_cumes(8,k)=sum(hh_cume(utility_demographics_matrices(:,:,1)==0 & utility_demographics_matrices(:,:,4)==1 & utility_demographics_matrices(:,:,10)==0))/ normalize(8);  

    predicted_demographic_cumes(1,k)=sum(hh_cume(cume_matrices(:,:,1)))/ normalize(1);
    predicted_demographic_cumes(2,k)=sum(hh_cume(cume_matrices(:,:,2)))/ normalize(2);    
    predicted_demographic_cumes(3,k)=sum(hh_cume(cume_matrices(:,:,3)))/ normalize(3);    
    predicted_demographic_cumes(4,k)=sum(hh_cume(cume_matrices(:,:,4)))/ normalize(4);
    predicted_demographic_cumes(5,k)=sum(hh_cume(cume_matrices(:,:,5)))/ normalize(5);    
    predicted_demographic_cumes(6,k)=sum(hh_cume(cume_matrices(:,:,6)))/ normalize(6);    
    predicted_demographic_cumes(7,k)=sum(hh_cume(cume_matrices(:,:,7)))/ normalize(7);
    predicted_demographic_cumes(8,k)=sum(hh_cume(cume_matrices(:,:,8)))/ normalize(8);    
    
    end
    
vector_predicted_mean_dma_ratings=reshape(predicted_mean_dma_ratings,numel(predicted_mean_dma_ratings),1);
vector_mean_dma_ratings=reshape(mean_dma_ratings,numel(mean_dma_ratings),1);

vector_predicted_nielsen_dma_demographics_covariance=reshape(predicted_nielsen_dma_demographics_covariance,numel(predicted_nielsen_dma_demographics_covariance),1);
vector_nielsen_dma_demographics_covariance=reshape(nielsen_dma_demographics_covariance,numel(nielsen_dma_demographics_covariance),1);

vector_predicted_mean_viewership_by_demographic=reshape(predicted_mean_viewership_by_demographic,numel(predicted_mean_viewership_by_demographic),1);
vector_mean_viewership_by_demographic=reshape(mean_viewership_by_demographic,numel(mean_viewership_by_demographic),1);

vector_predicted_covariance_in_hh_viewership = reshape(predicted_covariance_in_hh_viewership,numel(predicted_covariance_in_hh_viewership),1);
vector_covariance_in_hh_viewership = reshape(covariance_in_hh_viewership,numel(predicted_covariance_in_hh_viewership),1);

vector_predicted_cumes = reshape(predicted_demographic_cumes,numel(predicted_demographic_cumes),1);
vector_cumes = reshape(demographic_cume,numel(demographic_cume),1);

% predicted_f=[sqrt(2).*vector_predicted_mean_dma_ratings; vector_predicted_nielsen_dma_demographics_covariance; vector_predicted_mean_viewership_by_demographic; vector_predicted_covariance_in_hh_viewership/5; vector_predicted_cumes; 20*predicted_income_moments'];
% actual_f=[sqrt(2).*vector_mean_dma_ratings; vector_nielsen_dma_demographics_covariance; vector_mean_viewership_by_demographic; vector_covariance_in_hh_viewership/5; vector_cumes; 20*mediamark_income_moments'];
predicted_f=[vector_predicted_mean_dma_ratings; vector_predicted_nielsen_dma_demographics_covariance; vector_predicted_mean_viewership_by_demographic; vector_predicted_covariance_in_hh_viewership; vector_predicted_cumes; predicted_income_moments'];
actual_f=[vector_mean_dma_ratings; vector_nielsen_dma_demographics_covariance; vector_mean_viewership_by_demographic; vector_covariance_in_hh_viewership; vector_cumes; mediamark_income_moments'];

% if (knitro_or_fmin==1)
% pre_f=predicted_f-actual_f;
% f=.5*(pre_f'*pre_f);
% disp(f)
% else
%  f=predicted_f-actual_f;
% disp(.5*(f'*f))
% end
pre_f=predicted_f-actual_f;
f=.5*(pre_f'*pre_f);

if (no_display~=1)
% disp(f)
toc
end

