function [market_demographics_draws permuted_market_draws unobservable_draws fast_unobs_draws_matrix zero_out_draws fast_zero_out_draws utility_demographics_matrices income_matrix cume_matrices normalize]=set_random_draws(seed,demographics,simulations,dma_order,number_of_channels,homespassed_share)


%This is to save time by not repeating draws from the same market
market_marker=zeros(210,110);

% Family  Income  Black   Hispanic Asian  College Age
market_demographics_draws=zeros(210,110,simulations,7);
unobservable_draws=zeros(number_of_channels,simulations,210,110);
zero_out_draws=zeros(number_of_channels,simulations,210,110);
family_matrix=zeros(length(demographics),simulations);
income_matrix=zeros(length(demographics),simulations);
black_matrix=zeros(length(demographics),simulations);
asian_matrix=zeros(length(demographics),simulations);
hispanic_matrix=zeros(length(demographics),simulations);
college_matrix=zeros(length(demographics),simulations);
age_matrix=zeros(length(demographics),simulations);

% 6 dimensional Latin Random Hypercube draw
% You can put this within the loop for less simulation error, but it will
% be slower.
[ household_determination, s ] = latin_random ( 6, simulations, seed);   
household_determination=household_determination';

for k=1:length(demographics) 
disp(k)

    % Check if market has had demographic draws previously
    if (market_marker(dma_order(k,2),dma_order(k,3))==0)

%     [ household_determination, s ] = latin_random ( 6, simulations, seed);   
%     household_determination=household_determination';
    
        % Assigns characteristics to simulated households depending on
        % demographics of market and random draws of simulated household.
        
        family=(household_determination(:,1)<demographics(k,3));
        family_matrix(k,:)=family';
        
% demog_household_income_0_10	demog_household_income_10_25	demog_household_income_25_40	demog_household_income_40_60	demog_household_income_60_75	demog_household_income_75_100	demog_household_income_100_150	demog_household_income_150_plus
        income=(household_determination(:,2)<demographics(k,5)).*unifrnd(0,.1,simulations,1) + ...
        ((household_determination(:,2)>demographics(k,5)) & (household_determination(:,2)<sum(demographics(k,5:6))) ).*unifrnd(.10,.25,simulations,1) + ...
        ((household_determination(:,2)>sum(demographics(k,5:6))) & (household_determination(:,2)<sum(demographics(k,5:7))) ).*unifrnd(.25,.40,simulations,1) + ...
        ((household_determination(:,2)>sum(demographics(k,5:7))) & (household_determination(:,2)<sum(demographics(k,5:8))) ).*unifrnd(.4,.6,simulations,1) + ...
        ((household_determination(:,2)>sum(demographics(k,5:8))) & (household_determination(:,2)<sum(demographics(k,5:9))) ).*unifrnd(.6,.75,simulations,1) + ...
        ((household_determination(:,2)>sum(demographics(k,5:9))) & (household_determination(:,2)<sum(demographics(k,5:10))) ).*unifrnd(.75,1.0,simulations,1) + ...
        ((household_determination(:,2)>sum(demographics(k,5:10))) & (household_determination(:,2)<sum(demographics(k,5:11))) ).*unifrnd(1,1.5,simulations,1) + ...
        ((household_determination(:,2)>sum(demographics(k,5:11))) ).*unifrnd(1.5,2.00,simulations,1);
 
        income_matrix(k,:)=income; 

%         urban=(household_determination(:,3)<demographics(k,15));

        black=( (household_determination(:,4)>demographics(k,15)) & (household_determination(:,4)<sum(demographics(k,15:16))) );
        black_matrix(k,:)=black;
        
        asian=( (household_determination(:,4)>sum(demographics(k,15:16))) & (household_determination(:,4)<sum(demographics(k,15:17))) );
        asian_matrix(k,:)=asian;
        
        hispanic=( (household_determination(:,4)>sum(demographics(k,15:17))));
        hispanic_matrix(k,:)=hispanic;

        college=(household_determination(:,5)<sum(demographics(k,19:20)));
        college_matrix(k,:)=college;

        over_59=1-sum(demographics(k,21:end));
        age_denominator=sum(demographics(k,23:end))+over_59;
        age_18_to_30=demographics(k,23)/age_denominator;
        age_30_to_40=demographics(k,24)/age_denominator;
        age_40_to_59=demographics(k,25)/age_denominator;
        age_over_59=over_59/age_denominator;
        age =  ((household_determination(:,6)<age_18_to_30) ).*unifrnd(.18,.3,simulations,1) + ...
        ((household_determination(:,6)>age_18_to_30) & (household_determination(:,6)<(age_18_to_30+age_30_to_40)) ).*unifrnd(.3,.4,simulations,1) + ...
        ((household_determination(:,6)>(age_18_to_30+age_30_to_40)) & (household_determination(:,6)<(age_18_to_30+age_30_to_40+age_40_to_59))).*unifrnd(.4,.6,simulations,1) + ...
        ((household_determination(:,6)>1-age_over_59)).*unifrnd(.6,.75,simulations,1);
        age_matrix(k,:)=age;
        
        market_demographics_draws(dma_order(k,2),dma_order(k,3),:,:)=[family income black asian hispanic college age];

        market_marker(dma_order(k,2),dma_order(k,3))=k;
        
    [ G_determination, s ] = latin_random ( number_of_channels, simulations, seed+k);   
    unobservable_draws(:,:,dma_order(k,2),dma_order(k,3))=norminv(G_determination);
    
    [ pre_zero_out_draws, s ] = latin_random ( number_of_channels, simulations, seed+ceil(k*4.3));   
    zero_out_draws(:,:,dma_order(k,2),dma_order(k,3))=pre_zero_out_draws;
    
    else
        family_matrix(k,:)=family_matrix(market_marker(dma_order(k,2),dma_order(k,3)),:);
        income_matrix(k,:)=income_matrix(market_marker(dma_order(k,2),dma_order(k,3)),:);
        black_matrix(k,:)=black_matrix(market_marker(dma_order(k,2),dma_order(k,3)),:);
        asian_matrix(k,:)=asian_matrix(market_marker(dma_order(k,2),dma_order(k,3)),:);
        hispanic_matrix(k,:)=hispanic_matrix(market_marker(dma_order(k,2),dma_order(k,3)),:);
        college_matrix(k,:)=college_matrix(market_marker(dma_order(k,2),dma_order(k,3)),:);
        age_matrix(k,:)=age_matrix(market_marker(dma_order(k,2),dma_order(k,3)),:);
    end
end    

permuted_market_draws=permute(market_demographics_draws,[3 4 1 2]);

    year_matrix=dma_order(:,1)*ones(1,simulations);
    utility_demographics_matrices(:,:,1)=(family_matrix==1 & year_matrix>=2000 & year_matrix<=2007 );
    utility_demographics_matrices(:,:,2)=(income_matrix<.4 & year_matrix>=2000 & year_matrix<=2007 );
    utility_demographics_matrices(:,:,3)=(income_matrix>=.4 & year_matrix>=2000 & year_matrix<=2007);
    utility_demographics_matrices(:,:,4)=(black_matrix==1 & year_matrix>=2000 & year_matrix<=2007);
    utility_demographics_matrices(:,:,5)=(asian_matrix==1 & year_matrix>=2000 & year_matrix<=2007);
    utility_demographics_matrices(:,:,6)=(hispanic_matrix==1 & year_matrix>=2000 & year_matrix<=2007);
    utility_demographics_matrices(:,:,7)=(college_matrix==1 & year_matrix>=2000 & year_matrix<=2007);
    utility_demographics_matrices(:,:,8)=(age_matrix<.3 & year_matrix>=2000 & year_matrix<=2007);
    utility_demographics_matrices(:,:,9)=(age_matrix>=.3 & age_matrix<=.55 & year_matrix>=2000 & year_matrix<=2007);
    utility_demographics_matrices(:,:,10)=(age_matrix>.55 & year_matrix>=2000 & year_matrix<=2007);
    
    dma_id=dma_order(:,2);
    market_id=dma_order(:,3);
    fast_unobs_draws_matrix=zeros(number_of_channels,simulations,length(demographics) );
    fast_zero_out_draws=zeros(number_of_channels,simulations,length(demographics) );
    for i=1:length(demographics) 
    fast_unobs_draws_matrix(:,:,i)=unobservable_draws(:,:,dma_id(i),market_id(i));
    fast_zero_out_draws(:,:,i)=zero_out_draws(:,:,dma_id(i),market_id(i));
    end

cume_matrices(:,:,1)=utility_demographics_matrices(:,:,1)==1 & utility_demographics_matrices(:,:,4)==1 & utility_demographics_matrices(:,:,10)==1;    
cume_matrices(:,:,2)=utility_demographics_matrices(:,:,1)==1 & utility_demographics_matrices(:,:,4)==0 & utility_demographics_matrices(:,:,10)==1;    
cume_matrices(:,:,3)=utility_demographics_matrices(:,:,1)==1 & utility_demographics_matrices(:,:,4)==0 & utility_demographics_matrices(:,:,10)==0;    
cume_matrices(:,:,4)=utility_demographics_matrices(:,:,1)==1 & utility_demographics_matrices(:,:,4)==1 & utility_demographics_matrices(:,:,10)==0;    
cume_matrices(:,:,5)=utility_demographics_matrices(:,:,1)==0 & utility_demographics_matrices(:,:,4)==1 & utility_demographics_matrices(:,:,10)==1;    
cume_matrices(:,:,6)=utility_demographics_matrices(:,:,1)==0 & utility_demographics_matrices(:,:,4)==0 & utility_demographics_matrices(:,:,10)==1;    
cume_matrices(:,:,7)=utility_demographics_matrices(:,:,1)==0 & utility_demographics_matrices(:,:,4)==0 & utility_demographics_matrices(:,:,10)==0;    
cume_matrices(:,:,8)=utility_demographics_matrices(:,:,1)==0 & utility_demographics_matrices(:,:,4)==1 & utility_demographics_matrices(:,:,10)==0;    

    homespassed_matrix=homespassed_share*ones(1,simulations);
    normalize(1)=sum(homespassed_matrix(utility_demographics_matrices(:,:,1)==1 & utility_demographics_matrices(:,:,4)==1 & utility_demographics_matrices(:,:,10)==1));
    normalize(2)=sum(homespassed_matrix(utility_demographics_matrices(:,:,1)==1 & utility_demographics_matrices(:,:,4)==0 & utility_demographics_matrices(:,:,10)==1));
    normalize(3)=sum(homespassed_matrix(utility_demographics_matrices(:,:,1)==1 & utility_demographics_matrices(:,:,4)==0 & utility_demographics_matrices(:,:,10)==0));
    normalize(4)=sum(homespassed_matrix(utility_demographics_matrices(:,:,1)==1 & utility_demographics_matrices(:,:,4)==1 & utility_demographics_matrices(:,:,10)==0));
    normalize(5)=sum(homespassed_matrix(utility_demographics_matrices(:,:,1)==0 & utility_demographics_matrices(:,:,4)==1 & utility_demographics_matrices(:,:,10)==1));
    normalize(6)=sum(homespassed_matrix(utility_demographics_matrices(:,:,1)==0 & utility_demographics_matrices(:,:,4)==0 & utility_demographics_matrices(:,:,10)==1));
    normalize(7)=sum(homespassed_matrix(utility_demographics_matrices(:,:,1)==0 & utility_demographics_matrices(:,:,4)==0 & utility_demographics_matrices(:,:,10)==0));
    normalize(8)=sum(homespassed_matrix(utility_demographics_matrices(:,:,1)==0 & utility_demographics_matrices(:,:,4)==1 & utility_demographics_matrices(:,:,10)==0));
   