function [market_demographics_draws unobservable_draws zero_out_draws]=set_random_draws_single_market(seed,demographics,simulations,number_of_channels)
% Input demographics is  
% year	dma	demog_family_pct demog_family_3_or_more_pct	demog_household_income_0_10	demog_household_income_10_25	demog_household_income_25_40	demog_household_income_40_60	demog_household_income_60_75	demog_household_income_75_100	demog_household_income_100_150	demog_household_income_150_plus	demog_urban_pct	demog_rural_pct	demog_white_pct	demog_black_pct	demog_asian_pct	demog_hispanic_pct	demog_bachelors_degree_pct	demog_higher_degree_pct	demog_age_0_12	demog_age_13_18	demog_age_18_29	demog_age_30_39	demog_age_40_59

    %set default stream for replication purposes
    mtstream = RandStream('mt19937ar');
    RandStream.setDefaultStream(mtstream);

% 6 dimensional Latin Random Hypercube draw
% You can put this within the loop for less simulation error, but it will
% be slower.
[ household_determination, s ] = latin_random ( 6, simulations, seed);   
household_determination=household_determination';



        % Assigns characteristics to simulated households depending on
        % demographics of market and random draws of simulated household.
        
        family=(household_determination(:,1)<demographics(3));
        
% demog_household_income_0_10	demog_household_income_10_25	demog_household_income_25_40	demog_household_income_40_60	demog_household_income_60_75	demog_household_income_75_100	demog_household_income_100_150	demog_household_income_150_plus
        income=(household_determination(:,2)<demographics(5)).*unifrnd(0,.1,simulations,1) + ...
        ((household_determination(:,2)>demographics(5)) & (household_determination(:,2)<sum(demographics(5:6))) ).*unifrnd(.10,.25,simulations,1) + ...
        ((household_determination(:,2)>sum(demographics(5:6))) & (household_determination(:,2)<sum(demographics(5:7))) ).*unifrnd(.25,.40,simulations,1) + ...
        ((household_determination(:,2)>sum(demographics(5:7))) & (household_determination(:,2)<sum(demographics(5:8))) ).*unifrnd(.4,.6,simulations,1) + ...
        ((household_determination(:,2)>sum(demographics(5:8))) & (household_determination(:,2)<sum(demographics(5:9))) ).*unifrnd(.6,.75,simulations,1) + ...
        ((household_determination(:,2)>sum(demographics(5:9))) & (household_determination(:,2)<sum(demographics(5:10))) ).*unifrnd(.75,1.0,simulations,1) + ...
        ((household_determination(:,2)>sum(demographics(5:10))) & (household_determination(:,2)<sum(demographics(5:11))) ).*unifrnd(1,1.5,simulations,1) + ...
        ((household_determination(:,2)>sum(demographics(5:11))) ).*(unifrnd(1.5,2.0,simulations,1));
 
        black=( (household_determination(:,4)>demographics(15)) & (household_determination(:,4)<sum(demographics(15:16))) );
        
        asian=( (household_determination(:,4)>sum(demographics(15:16))) & (household_determination(:,4)<sum(demographics(15:17))) );
        
        hispanic=( (household_determination(:,4)>sum(demographics(15:17))));

        college=(household_determination(:,5)<sum(demographics(19:20)));

        over_59=1-sum(demographics(21:end));
        age_denominator=sum(demographics(23:end))+over_59;
        age_18_to_30=demographics(23)/age_denominator;
        age_30_to_40=demographics(24)/age_denominator;
        age_40_to_59=demographics(25)/age_denominator;
        age_over_59=over_59/age_denominator;
        age =  ((household_determination(:,6)<age_18_to_30) ).*unifrnd(.18,.3,simulations,1) + ...
        ((household_determination(:,6)>age_18_to_30) & (household_determination(:,6)<(age_18_to_30+age_30_to_40)) ).*unifrnd(.3,.4,simulations,1) + ...
        ((household_determination(:,6)>(age_18_to_30+age_30_to_40)) & (household_determination(:,6)<(age_18_to_30+age_30_to_40+age_40_to_59))).*unifrnd(.4,.6,simulations,1) + ...
        ((household_determination(:,6)>1-age_over_59)).*unifrnd(.6,.75,simulations,1);

        market_demographics_draws=[family income black asian hispanic college age];

       
    [ G_determination, s ] = latin_random ( number_of_channels, simulations, seed);   
    unobservable_draws=norminv(G_determination);
    
    [ pre_zero_out_draws, s ] = latin_random ( number_of_channels, simulations, seed);   
    zero_out_draws=pre_zero_out_draws;
    
   